<?php

require_once 'model/om/BasePage.php';


/**
 * Skeleton subclass for representing a row from the 'page' table.
 *
 * 
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package model
 */	
class Page extends BasePage {
  public function getPermanentTitle()
  {
    $result = strtolower($this->getTitle());

    $result = preg_replace('/\ +/', '-', $result);

    return $result;
  }
  

  
	public function getParsedText()
	{
    function parseTextCallback($matches)
    {
  	  use_helper('Url');
  	  $match = $matches[1];
  	  $match = strtolower($match);
  	  $stripped = preg_replace('/\ +/', '-', $match);
  	  return link_to($match, 'page/edit?title='.$stripped);
    }
    
	  use_helper('Url');
	  
	  // Get the titles from db.
	  $titles = PagePeer::getJustTitle(new Criteria());

	  // Process the raw text
	  
	  // Change the [*] to a link.
	  $result = $this->text;
	  $result = preg_replace_callback('/\[([^\[\]]+)\]/', 'parseTextCallback', $result);
		return $result;
	}
	
	public function getText()
	{
		return $this->text;
	}
} // Page
