<?php
		
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';


/**
 * This class adds structure of 'forum' table to 'symfony' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @package model.map
 */	
class ForumMapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'model.map.ForumMapBuilder';	

    /**
     * The database map.
     */
    private $dbMap;

	/**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return boolean true if this DatabaseMapBuilder is built, false otherwise.
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

	/**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap('symfony');
		
		$tMap = $this->dbMap->addTable('forum');
		$tMap->setPhpName('Forum');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true);

		$tMap->addForeignPrimaryKey('CATEGORY_ID', 'CategoryId', 'int' , CreoleTypes::INTEGER, 'category', 'ID', true);

		$tMap->addColumn('NAME', 'Name', 'string', CreoleTypes::VARCHAR, true, 64);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addColumn('ORDER', 'Order', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('STATUS', 'Status', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('POSTS', 'Posts', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('TOPICS', 'Topics', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addForeignKey('LAST_POSTER', 'LastPoster', 'int', CreoleTypes::INTEGER, 'user', 'ID', true);

		$tMap->addColumn('AUTH_VIEW', 'AuthView', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_READ', 'AuthRead', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_POST', 'AuthPost', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_REPLY', 'AuthReply', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_EDIT', 'AuthEdit', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_DELETE', 'AuthDelete', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_STICKY', 'AuthSticky', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_ANNOUNCE', 'AuthAnnounce', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_VOTE', 'AuthVote', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_POLLCREATE', 'AuthPollcreate', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('AUTH_ATTATCHMENT', 'AuthAttatchment', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('CUSTOM_INFO', 'CustomInfo', 'string', CreoleTypes::LONGVARCHAR, false, null);
				
    } // doBuild()

} // ForumMapBuilder
