<?php
		
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';


/**
 * This class adds structure of 'post' table to 'symfony' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @package model.map
 */	
class PostMapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'model.map.PostMapBuilder';	

    /**
     * The database map.
     */
    private $dbMap;

	/**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return boolean true if this DatabaseMapBuilder is built, false otherwise.
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

	/**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap('symfony');
		
		$tMap = $this->dbMap->addTable('post');
		$tMap->setPhpName('Post');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true);

		$tMap->addForeignPrimaryKey('TOPIC_ID', 'TopicId', 'int' , CreoleTypes::INTEGER, 'topic', 'ID', true);

		$tMap->addForeignPrimaryKey('FORUM_ID', 'ForumId', 'int' , CreoleTypes::INTEGER, 'forum', 'ID', true);

		$tMap->addForeignKey('POSTER', 'Poster', 'int', CreoleTypes::INTEGER, 'user', 'ID', true);

		$tMap->addColumn('POSTER_IP', 'PosterIp', 'string', CreoleTypes::VARCHAR, true, 64);

		$tMap->addColumn('POSTER_USERNAME', 'PosterUsername', 'string', CreoleTypes::VARCHAR, true, 128);

		$tMap->addColumn('CREATED_AT', 'CreatedAt', 'int', CreoleTypes::TIMESTAMP, true, null);

		$tMap->addColumn('UPDATED_AT', 'UpdatedAt', 'int', CreoleTypes::TIMESTAMP, true, null);

		$tMap->addForeignKey('REPLY_OF', 'ReplyOf', 'int', CreoleTypes::INTEGER, 'post', 'ID', false);

		$tMap->addColumn('TEXT', 'Text', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addColumn('CUSTOM_INFO', 'CustomInfo', 'string', CreoleTypes::LONGVARCHAR, false, null);
				
    } // doBuild()

} // PostMapBuilder
