<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'model/CategoryPeer.php';

/**
 * Base class that represents a row from the 'category' table.
 *
 * 
 *
 * @package model.om
 */	
abstract class BaseCategory extends BaseObject  implements Persistent {


	/**
	 * phpname type
	 * e.g. 'AuthorId'
	 */
	const TYPE_PHPNAME = 'phpName';

	/**
	 * column (peer) name type
	 * e.g. 'book.AUTHOR_ID'
	 */
	const TYPE_COLNAME = 'colName';

	/**
	 * column fieldname type
	 * e.g. 'author_id'
	 */
	const TYPE_FIELDNAME = 'fieldName';

	/**
	 * num type
	 * simply the numerical array index, e.g. 4
	 */
	const TYPE_NUM = 'num';

	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var CategoryPeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var int
	 */
	protected $id;


	/**
	 * The value for the name field.
	 * @var string
	 */
	protected $name;


	/**
	 * The value for the description field.
	 * @var string
	 */
	protected $description;


	/**
	 * The value for the order field.
	 * @var int
	 */
	protected $order;


	/**
	 * The value for the custom_info field.
	 * @var string
	 */
	protected $custom_info;

	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		Category::TYPE_PHPNAME => array ('Id', 'Name', 'Description', 'Order', 'CustomInfo', ),
		Category::TYPE_COLNAME => array (CategoryPeer::ID, CategoryPeer::NAME, CategoryPeer::DESCRIPTION, CategoryPeer::ORDER, CategoryPeer::CUSTOM_INFO, ),
		
		Category::TYPE_FIELDNAME => array ('id', 'name', 'description', 'order', 'custom_info', ),
		
		Category::TYPE_NUM => array (0, 1, 2, 3, 4, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		Category::TYPE_PHPNAME => array ('Id' => 0, 'Name' => 1, 'Description' => 2, 'Order' => 3, 'CustomInfo' => 4, ),
		Category::TYPE_COLNAME => array (CategoryPeer::ID => 0, CategoryPeer::NAME => 1, CategoryPeer::DESCRIPTION => 2, CategoryPeer::ORDER => 3, CategoryPeer::CUSTOM_INFO => 4, ),
		
		Category::TYPE_FIELDNAME => array ('id' => 0, 'name' => 1, 'description' => 2, 'order' => 3, 'custom_info' => 4, ),
		
		Category::TYPE_NUM => array (0, 1, 2, 3, 4, )
	);

	/**
	 * Collection to store aggregation of collForums.
	 * @var array
	 */
	protected $collForums;
	
	/**
	 * The criteria used to select the current contents of collForums.
	 * @var Criteria
	 */
	private $lastForumCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return string
	 */
	public function getName()
	{

		return $this->name;
	}

	/**
	 * Get the [description] column value.
	 * 
	 * @return string
	 */
	public function getDescription()
	{

		return $this->description;
	}

	/**
	 * Get the [order] column value.
	 * 
	 * @return int
	 */
	public function getOrder()
	{

		return $this->order;
	}

	/**
	 * Get the [custom_info] column value.
	 * 
	 * @return string
	 */
	public function getCustomInfo()
	{

		return $this->custom_info;
	}

	/**
	 * Set the value of [id] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setId($v)
	{

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = CategoryPeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [name] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setName($v)
	{

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = CategoryPeer::NAME;
		}

	} // setName()

	/**
	 * Set the value of [description] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setDescription($v)
	{

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = CategoryPeer::DESCRIPTION;
		}

	} // setDescription()

	/**
	 * Set the value of [order] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setOrder($v)
	{

		if ($this->order !== $v) {
			$this->order = $v;
			$this->modifiedColumns[] = CategoryPeer::ORDER;
		}

	} // setOrder()

	/**
	 * Set the value of [custom_info] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setCustomInfo($v)
	{

		if ($this->custom_info !== $v) {
			$this->custom_info = $v;
			$this->modifiedColumns[] = CategoryPeer::CUSTOM_INFO;
		}

	} // setCustomInfo()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->name = $rs->getString($startcol + 1);

			$this->description = $rs->getString($startcol + 2);

			$this->order = $rs->getInt($startcol + 3);

			$this->custom_info = $rs->getString($startcol + 4);

			$this->resetModified();

			$this->setNew(false);
						
			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 5; // 5 = CategoryPeer::NUM_COLUMNS - CategoryPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Category object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CategoryPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			CategoryPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(CategoryPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = CategoryPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += CategoryPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collForums !== null) {
				foreach($this->collForums as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 * @see doValidate()
	 */
	public function validate($columns = null)
	{
	  if ($columns) {
		return CategoryPeer::doValidate($this, $columns);
	  }
		return $this->doValidate();
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = CategoryPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collForums !== null) {
					foreach($this->collForums as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Translates a fieldname to another type
	 *
	 * @param string $name field name
	 * @param string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param string $toType   One of the class type constants
	 * @return string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = self::$fieldKeys[$fromType][$name];
		if ($key === false) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r($fromNames, true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param  string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return array A list of field names
	 */

	static public function getFieldNames($type = self::TYPE_FIELDNAME)
	{
		if (!isset(self::$fieldNames[$type])) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = self::TYPE_COLNAME)
	{
		$names = self::getFieldNames($type);
		$pos = self::translateFieldName($name, $type, self::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {

			case 0:
				return $this->getId();
				break;

			case 1:
				return $this->getName();
				break;

			case 2:
				return $this->getDescription();
				break;

			case 3:
				return $this->getOrder();
				break;

			case 4:
				return $this->getCustomInfo();
				break;

			default:
				return null;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = self::TYPE_PHPNAME)
	{
		$keys = self::getFieldNames($keyType);
		$result = array(

			$keys[0] => $this->getId(),

			$keys[1] => $this->getName(),

			$keys[2] => $this->getDescription(),

			$keys[3] => $this->getOrder(),

			$keys[4] => $this->getCustomInfo(),

		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = self::TYPE_COLNAME)
	{
		$names = $this->getFieldnames($type);
		$pos = array_search($name, $names);
		return $this->setByPosition($pos, $name);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {

			case 0:
				$this->setId($value);
				break;
		
			case 1:
				$this->setName($value);
				break;
		
			case 2:
				$this->setDescription($value);
				break;
		
			case 3:
				$this->setOrder($value);
				break;
		
			case 4:
				$this->setCustomInfo($value);
				break;
		
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the (peer) column name (e.g.
	 * 'book.AUTHOR_ID')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = self::TYPE_COLNAME)
	{
		$keys = self::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);

		if (array_key_exists($keys[1], $arr)) $this->setName($arr[$keys[1]]);

		if (array_key_exists($keys[2], $arr)) $this->setDescription($arr[$keys[2]]);

		if (array_key_exists($keys[3], $arr)) $this->setOrder($arr[$keys[3]]);

		if (array_key_exists($keys[4], $arr)) $this->setCustomInfo($arr[$keys[4]]);

	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(CategoryPeer::DATABASE_NAME);

		if ($this->isColumnModified(CategoryPeer::ID)) $criteria->add(CategoryPeer::ID, $this->id);

		if ($this->isColumnModified(CategoryPeer::NAME)) $criteria->add(CategoryPeer::NAME, $this->name);

		if ($this->isColumnModified(CategoryPeer::DESCRIPTION)) $criteria->add(CategoryPeer::DESCRIPTION, $this->description);

		if ($this->isColumnModified(CategoryPeer::ORDER)) $criteria->add(CategoryPeer::ORDER, $this->order);

		if ($this->isColumnModified(CategoryPeer::CUSTOM_INFO)) $criteria->add(CategoryPeer::CUSTOM_INFO, $this->custom_info);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(CategoryPeer::DATABASE_NAME);

		$criteria->add(CategoryPeer::ID, $this->id);

		$criteria->add(CategoryPeer::ORDER, $this->order);

		return $criteria;
	}

	/**
	 * Returns the composite primary key for this object.
	 * The array elements will be in same order as specified in XML.
	 * @return array
	 */
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getId();

		$pks[1] = $this->getOrder();

		return $pks;
	}

	/**
	 * Set the [composite] primary key.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 */
	public function setPrimaryKey($keys)
	{

		$this->setId($keys[0]);

		$this->setOrder($keys[1]);

	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Category (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setName($this->name);

		$copyObj->setDescription($this->description);

		$copyObj->setCustomInfo($this->custom_info);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getForums() as $relObj) {
				$copyObj->addForum($relObj->copy());
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

		$copyObj->setOrder(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Category Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * 
	 * @return CategoryPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new CategoryPeer();
		}
		return self::$peer;
	}

	/**
	 * Temporary storage of collForums to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initForums()
	{
		if ($this->collForums === null) {
			$this->collForums = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Category has previously
	 * been saved, it will retrieve related Forums from storage.
	 * If this Category is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getForums($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseForumPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collForums === null) {
			if ($this->isNew()) {
			   $this->collForums = array();
			} else {

				$criteria->add(ForumPeer::CATEGORY_ID, $this->getId());

				ForumPeer::addSelectColumns($criteria);
				$this->collForums = ForumPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ForumPeer::CATEGORY_ID, $this->getId());

				ForumPeer::addSelectColumns($criteria);
				if (!isset($this->lastForumCriteria) || !$this->lastForumCriteria->equals($criteria)) {
					$this->collForums = ForumPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastForumCriteria = $criteria;
		return $this->collForums;
	}

	/**
	 * Returns the number of related Forums.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countForums($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseForumPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(ForumPeer::CATEGORY_ID, $this->getId());

		return ForumPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Forum object to this object
	 * through the Forum foreign key attribute
	 *
	 * @param Forum $l Forum
	 * @return void
	 * @throws PropelException
	 */
	public function addForum(Forum $l)
	{
		$this->collForums[] = $l;
		$l->setCategory($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Category is new, it will return
	 * an empty collection; or if this Category has previously
	 * been saved, it will retrieve related Forums from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Category.
	 */
	public function getForumsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseForumPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collForums === null) {
			if ($this->isNew()) {
				$this->collForums = array();
			} else {

				$criteria->add(ForumPeer::CATEGORY_ID, $this->getId());

				$this->collForums = ForumPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ForumPeer::CATEGORY_ID, $this->getId());

			if (!isset($this->lastForumCriteria) || !$this->lastForumCriteria->equals($criteria)) {
				$this->collForums = ForumPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastForumCriteria = $criteria;

		return $this->collForums;
	}

} // BaseCategory
