<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'model/ForumPeer.php';

/**
 * Base class that represents a row from the 'forum' table.
 *
 * 
 *
 * @package model.om
 */	
abstract class BaseForum extends BaseObject  implements Persistent {


	/**
	 * phpname type
	 * e.g. 'AuthorId'
	 */
	const TYPE_PHPNAME = 'phpName';

	/**
	 * column (peer) name type
	 * e.g. 'book.AUTHOR_ID'
	 */
	const TYPE_COLNAME = 'colName';

	/**
	 * column fieldname type
	 * e.g. 'author_id'
	 */
	const TYPE_FIELDNAME = 'fieldName';

	/**
	 * num type
	 * simply the numerical array index, e.g. 4
	 */
	const TYPE_NUM = 'num';

	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ForumPeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var int
	 */
	protected $id;


	/**
	 * The value for the category_id field.
	 * @var int
	 */
	protected $category_id;


	/**
	 * The value for the name field.
	 * @var string
	 */
	protected $name;


	/**
	 * The value for the description field.
	 * @var string
	 */
	protected $description;


	/**
	 * The value for the order field.
	 * @var int
	 */
	protected $order;


	/**
	 * The value for the status field.
	 * @var int
	 */
	protected $status;


	/**
	 * The value for the posts field.
	 * @var int
	 */
	protected $posts;


	/**
	 * The value for the topics field.
	 * @var int
	 */
	protected $topics;


	/**
	 * The value for the last_poster field.
	 * @var int
	 */
	protected $last_poster;


	/**
	 * The value for the auth_view field.
	 * @var int
	 */
	protected $auth_view;


	/**
	 * The value for the auth_read field.
	 * @var int
	 */
	protected $auth_read;


	/**
	 * The value for the auth_post field.
	 * @var int
	 */
	protected $auth_post;


	/**
	 * The value for the auth_reply field.
	 * @var int
	 */
	protected $auth_reply;


	/**
	 * The value for the auth_edit field.
	 * @var int
	 */
	protected $auth_edit;


	/**
	 * The value for the auth_delete field.
	 * @var int
	 */
	protected $auth_delete;


	/**
	 * The value for the auth_sticky field.
	 * @var int
	 */
	protected $auth_sticky;


	/**
	 * The value for the auth_announce field.
	 * @var int
	 */
	protected $auth_announce;


	/**
	 * The value for the auth_vote field.
	 * @var int
	 */
	protected $auth_vote;


	/**
	 * The value for the auth_pollcreate field.
	 * @var int
	 */
	protected $auth_pollcreate;


	/**
	 * The value for the auth_attatchment field.
	 * @var int
	 */
	protected $auth_attatchment;


	/**
	 * The value for the custom_info field.
	 * @var string
	 */
	protected $custom_info;

	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		Forum::TYPE_PHPNAME => array ('Id', 'CategoryId', 'Name', 'Description', 'Order', 'Status', 'Posts', 'Topics', 'LastPoster', 'AuthView', 'AuthRead', 'AuthPost', 'AuthReply', 'AuthEdit', 'AuthDelete', 'AuthSticky', 'AuthAnnounce', 'AuthVote', 'AuthPollcreate', 'AuthAttatchment', 'CustomInfo', ),
		Forum::TYPE_COLNAME => array (ForumPeer::ID, ForumPeer::CATEGORY_ID, ForumPeer::NAME, ForumPeer::DESCRIPTION, ForumPeer::ORDER, ForumPeer::STATUS, ForumPeer::POSTS, ForumPeer::TOPICS, ForumPeer::LAST_POSTER, ForumPeer::AUTH_VIEW, ForumPeer::AUTH_READ, ForumPeer::AUTH_POST, ForumPeer::AUTH_REPLY, ForumPeer::AUTH_EDIT, ForumPeer::AUTH_DELETE, ForumPeer::AUTH_STICKY, ForumPeer::AUTH_ANNOUNCE, ForumPeer::AUTH_VOTE, ForumPeer::AUTH_POLLCREATE, ForumPeer::AUTH_ATTATCHMENT, ForumPeer::CUSTOM_INFO, ),
		
		Forum::TYPE_FIELDNAME => array ('id', 'category_id', 'name', 'description', 'order', 'status', 'posts', 'topics', 'last_poster', 'auth_view', 'auth_read', 'auth_post', 'auth_reply', 'auth_edit', 'auth_delete', 'auth_sticky', 'auth_announce', 'auth_vote', 'auth_pollcreate', 'auth_attatchment', 'custom_info', ),
		
		Forum::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		Forum::TYPE_PHPNAME => array ('Id' => 0, 'CategoryId' => 1, 'Name' => 2, 'Description' => 3, 'Order' => 4, 'Status' => 5, 'Posts' => 6, 'Topics' => 7, 'LastPoster' => 8, 'AuthView' => 9, 'AuthRead' => 10, 'AuthPost' => 11, 'AuthReply' => 12, 'AuthEdit' => 13, 'AuthDelete' => 14, 'AuthSticky' => 15, 'AuthAnnounce' => 16, 'AuthVote' => 17, 'AuthPollcreate' => 18, 'AuthAttatchment' => 19, 'CustomInfo' => 20, ),
		Forum::TYPE_COLNAME => array (ForumPeer::ID => 0, ForumPeer::CATEGORY_ID => 1, ForumPeer::NAME => 2, ForumPeer::DESCRIPTION => 3, ForumPeer::ORDER => 4, ForumPeer::STATUS => 5, ForumPeer::POSTS => 6, ForumPeer::TOPICS => 7, ForumPeer::LAST_POSTER => 8, ForumPeer::AUTH_VIEW => 9, ForumPeer::AUTH_READ => 10, ForumPeer::AUTH_POST => 11, ForumPeer::AUTH_REPLY => 12, ForumPeer::AUTH_EDIT => 13, ForumPeer::AUTH_DELETE => 14, ForumPeer::AUTH_STICKY => 15, ForumPeer::AUTH_ANNOUNCE => 16, ForumPeer::AUTH_VOTE => 17, ForumPeer::AUTH_POLLCREATE => 18, ForumPeer::AUTH_ATTATCHMENT => 19, ForumPeer::CUSTOM_INFO => 20, ),
		
		Forum::TYPE_FIELDNAME => array ('id' => 0, 'category_id' => 1, 'name' => 2, 'description' => 3, 'order' => 4, 'status' => 5, 'posts' => 6, 'topics' => 7, 'last_poster' => 8, 'auth_view' => 9, 'auth_read' => 10, 'auth_post' => 11, 'auth_reply' => 12, 'auth_edit' => 13, 'auth_delete' => 14, 'auth_sticky' => 15, 'auth_announce' => 16, 'auth_vote' => 17, 'auth_pollcreate' => 18, 'auth_attatchment' => 19, 'custom_info' => 20, ),
		
		Forum::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, )
	);

	/**
	 * @var Category
	 */
	protected $aCategory;

	/**
	 * @var User
	 */
	protected $aUser;

	/**
	 * Collection to store aggregation of collTopics.
	 * @var array
	 */
	protected $collTopics;
	
	/**
	 * The criteria used to select the current contents of collTopics.
	 * @var Criteria
	 */
	private $lastTopicCriteria = null;

	/**
	 * Collection to store aggregation of collPosts.
	 * @var array
	 */
	protected $collPosts;
	
	/**
	 * The criteria used to select the current contents of collPosts.
	 * @var Criteria
	 */
	private $lastPostCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [category_id] column value.
	 * 
	 * @return int
	 */
	public function getCategoryId()
	{

		return $this->category_id;
	}

	/**
	 * Get the [name] column value.
	 * 
	 * @return string
	 */
	public function getName()
	{

		return $this->name;
	}

	/**
	 * Get the [description] column value.
	 * 
	 * @return string
	 */
	public function getDescription()
	{

		return $this->description;
	}

	/**
	 * Get the [order] column value.
	 * 
	 * @return int
	 */
	public function getOrder()
	{

		return $this->order;
	}

	/**
	 * Get the [status] column value.
	 * 
	 * @return int
	 */
	public function getStatus()
	{

		return $this->status;
	}

	/**
	 * Get the [posts] column value.
	 * 
	 * @return int
	 */
	public function getPosts()
	{

		return $this->posts;
	}

	/**
	 * Get the [topics] column value.
	 * 
	 * @return int
	 */
	public function getTopics()
	{

		return $this->topics;
	}

	/**
	 * Get the [last_poster] column value.
	 * 
	 * @return int
	 */
	public function getLastPoster()
	{

		return $this->last_poster;
	}

	/**
	 * Get the [auth_view] column value.
	 * 
	 * @return int
	 */
	public function getAuthView()
	{

		return $this->auth_view;
	}

	/**
	 * Get the [auth_read] column value.
	 * 
	 * @return int
	 */
	public function getAuthRead()
	{

		return $this->auth_read;
	}

	/**
	 * Get the [auth_post] column value.
	 * 
	 * @return int
	 */
	public function getAuthPost()
	{

		return $this->auth_post;
	}

	/**
	 * Get the [auth_reply] column value.
	 * 
	 * @return int
	 */
	public function getAuthReply()
	{

		return $this->auth_reply;
	}

	/**
	 * Get the [auth_edit] column value.
	 * 
	 * @return int
	 */
	public function getAuthEdit()
	{

		return $this->auth_edit;
	}

	/**
	 * Get the [auth_delete] column value.
	 * 
	 * @return int
	 */
	public function getAuthDelete()
	{

		return $this->auth_delete;
	}

	/**
	 * Get the [auth_sticky] column value.
	 * 
	 * @return int
	 */
	public function getAuthSticky()
	{

		return $this->auth_sticky;
	}

	/**
	 * Get the [auth_announce] column value.
	 * 
	 * @return int
	 */
	public function getAuthAnnounce()
	{

		return $this->auth_announce;
	}

	/**
	 * Get the [auth_vote] column value.
	 * 
	 * @return int
	 */
	public function getAuthVote()
	{

		return $this->auth_vote;
	}

	/**
	 * Get the [auth_pollcreate] column value.
	 * 
	 * @return int
	 */
	public function getAuthPollcreate()
	{

		return $this->auth_pollcreate;
	}

	/**
	 * Get the [auth_attatchment] column value.
	 * 
	 * @return int
	 */
	public function getAuthAttatchment()
	{

		return $this->auth_attatchment;
	}

	/**
	 * Get the [custom_info] column value.
	 * 
	 * @return string
	 */
	public function getCustomInfo()
	{

		return $this->custom_info;
	}

	/**
	 * Set the value of [id] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setId($v)
	{

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = ForumPeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [category_id] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setCategoryId($v)
	{

		if ($this->category_id !== $v) {
			$this->category_id = $v;
			$this->modifiedColumns[] = ForumPeer::CATEGORY_ID;
		}

		if ($this->aCategory !== null && $this->aCategory->getId() !== $v) {
			$this->aCategory = null;
		}		

	} // setCategoryId()

	/**
	 * Set the value of [name] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setName($v)
	{

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = ForumPeer::NAME;
		}

	} // setName()

	/**
	 * Set the value of [description] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setDescription($v)
	{

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = ForumPeer::DESCRIPTION;
		}

	} // setDescription()

	/**
	 * Set the value of [order] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setOrder($v)
	{

		if ($this->order !== $v) {
			$this->order = $v;
			$this->modifiedColumns[] = ForumPeer::ORDER;
		}

	} // setOrder()

	/**
	 * Set the value of [status] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setStatus($v)
	{

		if ($this->status !== $v) {
			$this->status = $v;
			$this->modifiedColumns[] = ForumPeer::STATUS;
		}

	} // setStatus()

	/**
	 * Set the value of [posts] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setPosts($v)
	{

		if ($this->posts !== $v) {
			$this->posts = $v;
			$this->modifiedColumns[] = ForumPeer::POSTS;
		}

	} // setPosts()

	/**
	 * Set the value of [topics] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setTopics($v)
	{

		if ($this->topics !== $v) {
			$this->topics = $v;
			$this->modifiedColumns[] = ForumPeer::TOPICS;
		}

	} // setTopics()

	/**
	 * Set the value of [last_poster] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setLastPoster($v)
	{

		if ($this->last_poster !== $v) {
			$this->last_poster = $v;
			$this->modifiedColumns[] = ForumPeer::LAST_POSTER;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}		

	} // setLastPoster()

	/**
	 * Set the value of [auth_view] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthView($v)
	{

		if ($this->auth_view !== $v) {
			$this->auth_view = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_VIEW;
		}

	} // setAuthView()

	/**
	 * Set the value of [auth_read] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthRead($v)
	{

		if ($this->auth_read !== $v) {
			$this->auth_read = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_READ;
		}

	} // setAuthRead()

	/**
	 * Set the value of [auth_post] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthPost($v)
	{

		if ($this->auth_post !== $v) {
			$this->auth_post = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_POST;
		}

	} // setAuthPost()

	/**
	 * Set the value of [auth_reply] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthReply($v)
	{

		if ($this->auth_reply !== $v) {
			$this->auth_reply = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_REPLY;
		}

	} // setAuthReply()

	/**
	 * Set the value of [auth_edit] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthEdit($v)
	{

		if ($this->auth_edit !== $v) {
			$this->auth_edit = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_EDIT;
		}

	} // setAuthEdit()

	/**
	 * Set the value of [auth_delete] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthDelete($v)
	{

		if ($this->auth_delete !== $v) {
			$this->auth_delete = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_DELETE;
		}

	} // setAuthDelete()

	/**
	 * Set the value of [auth_sticky] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthSticky($v)
	{

		if ($this->auth_sticky !== $v) {
			$this->auth_sticky = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_STICKY;
		}

	} // setAuthSticky()

	/**
	 * Set the value of [auth_announce] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthAnnounce($v)
	{

		if ($this->auth_announce !== $v) {
			$this->auth_announce = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_ANNOUNCE;
		}

	} // setAuthAnnounce()

	/**
	 * Set the value of [auth_vote] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthVote($v)
	{

		if ($this->auth_vote !== $v) {
			$this->auth_vote = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_VOTE;
		}

	} // setAuthVote()

	/**
	 * Set the value of [auth_pollcreate] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthPollcreate($v)
	{

		if ($this->auth_pollcreate !== $v) {
			$this->auth_pollcreate = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_POLLCREATE;
		}

	} // setAuthPollcreate()

	/**
	 * Set the value of [auth_attatchment] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthAttatchment($v)
	{

		if ($this->auth_attatchment !== $v) {
			$this->auth_attatchment = $v;
			$this->modifiedColumns[] = ForumPeer::AUTH_ATTATCHMENT;
		}

	} // setAuthAttatchment()

	/**
	 * Set the value of [custom_info] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setCustomInfo($v)
	{

		if ($this->custom_info !== $v) {
			$this->custom_info = $v;
			$this->modifiedColumns[] = ForumPeer::CUSTOM_INFO;
		}

	} // setCustomInfo()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->category_id = $rs->getInt($startcol + 1);

			$this->name = $rs->getString($startcol + 2);

			$this->description = $rs->getString($startcol + 3);

			$this->order = $rs->getInt($startcol + 4);

			$this->status = $rs->getInt($startcol + 5);

			$this->posts = $rs->getInt($startcol + 6);

			$this->topics = $rs->getInt($startcol + 7);

			$this->last_poster = $rs->getInt($startcol + 8);

			$this->auth_view = $rs->getInt($startcol + 9);

			$this->auth_read = $rs->getInt($startcol + 10);

			$this->auth_post = $rs->getInt($startcol + 11);

			$this->auth_reply = $rs->getInt($startcol + 12);

			$this->auth_edit = $rs->getInt($startcol + 13);

			$this->auth_delete = $rs->getInt($startcol + 14);

			$this->auth_sticky = $rs->getInt($startcol + 15);

			$this->auth_announce = $rs->getInt($startcol + 16);

			$this->auth_vote = $rs->getInt($startcol + 17);

			$this->auth_pollcreate = $rs->getInt($startcol + 18);

			$this->auth_attatchment = $rs->getInt($startcol + 19);

			$this->custom_info = $rs->getString($startcol + 20);

			$this->resetModified();

			$this->setNew(false);
						
			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 21; // 21 = ForumPeer::NUM_COLUMNS - ForumPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Forum object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ForumPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			ForumPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(ForumPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aCategory !== null) {
				if ($this->aCategory->isModified()) {
					$affectedRows += $this->aCategory->save($con);
				}
				$this->setCategory($this->aCategory);
			}

			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ForumPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += ForumPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collTopics !== null) {
				foreach($this->collTopics as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collPosts !== null) {
				foreach($this->collPosts as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 * @see doValidate()
	 */
	public function validate($columns = null)
	{
	  if ($columns) {
		return ForumPeer::doValidate($this, $columns);
	  }
		return $this->doValidate();
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aCategory !== null) {
				if (($retval = $this->aCategory->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}


			if (($retval = ForumPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collTopics !== null) {
					foreach($this->collTopics as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}

				if ($this->collPosts !== null) {
					foreach($this->collPosts as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Translates a fieldname to another type
	 *
	 * @param string $name field name
	 * @param string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param string $toType   One of the class type constants
	 * @return string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = self::$fieldKeys[$fromType][$name];
		if ($key === false) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r($fromNames, true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param  string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return array A list of field names
	 */

	static public function getFieldNames($type = self::TYPE_FIELDNAME)
	{
		if (!isset(self::$fieldNames[$type])) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = self::TYPE_COLNAME)
	{
		$names = self::getFieldNames($type);
		$pos = self::translateFieldName($name, $type, self::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {

			case 0:
				return $this->getId();
				break;

			case 1:
				return $this->getCategoryId();
				break;

			case 2:
				return $this->getName();
				break;

			case 3:
				return $this->getDescription();
				break;

			case 4:
				return $this->getOrder();
				break;

			case 5:
				return $this->getStatus();
				break;

			case 6:
				return $this->getPosts();
				break;

			case 7:
				return $this->getTopics();
				break;

			case 8:
				return $this->getLastPoster();
				break;

			case 9:
				return $this->getAuthView();
				break;

			case 10:
				return $this->getAuthRead();
				break;

			case 11:
				return $this->getAuthPost();
				break;

			case 12:
				return $this->getAuthReply();
				break;

			case 13:
				return $this->getAuthEdit();
				break;

			case 14:
				return $this->getAuthDelete();
				break;

			case 15:
				return $this->getAuthSticky();
				break;

			case 16:
				return $this->getAuthAnnounce();
				break;

			case 17:
				return $this->getAuthVote();
				break;

			case 18:
				return $this->getAuthPollcreate();
				break;

			case 19:
				return $this->getAuthAttatchment();
				break;

			case 20:
				return $this->getCustomInfo();
				break;

			default:
				return null;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = self::TYPE_PHPNAME)
	{
		$keys = self::getFieldNames($keyType);
		$result = array(

			$keys[0] => $this->getId(),

			$keys[1] => $this->getCategoryId(),

			$keys[2] => $this->getName(),

			$keys[3] => $this->getDescription(),

			$keys[4] => $this->getOrder(),

			$keys[5] => $this->getStatus(),

			$keys[6] => $this->getPosts(),

			$keys[7] => $this->getTopics(),

			$keys[8] => $this->getLastPoster(),

			$keys[9] => $this->getAuthView(),

			$keys[10] => $this->getAuthRead(),

			$keys[11] => $this->getAuthPost(),

			$keys[12] => $this->getAuthReply(),

			$keys[13] => $this->getAuthEdit(),

			$keys[14] => $this->getAuthDelete(),

			$keys[15] => $this->getAuthSticky(),

			$keys[16] => $this->getAuthAnnounce(),

			$keys[17] => $this->getAuthVote(),

			$keys[18] => $this->getAuthPollcreate(),

			$keys[19] => $this->getAuthAttatchment(),

			$keys[20] => $this->getCustomInfo(),

		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = self::TYPE_COLNAME)
	{
		$names = $this->getFieldnames($type);
		$pos = array_search($name, $names);
		return $this->setByPosition($pos, $name);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {

			case 0:
				$this->setId($value);
				break;
		
			case 1:
				$this->setCategoryId($value);
				break;
		
			case 2:
				$this->setName($value);
				break;
		
			case 3:
				$this->setDescription($value);
				break;
		
			case 4:
				$this->setOrder($value);
				break;
		
			case 5:
				$this->setStatus($value);
				break;
		
			case 6:
				$this->setPosts($value);
				break;
		
			case 7:
				$this->setTopics($value);
				break;
		
			case 8:
				$this->setLastPoster($value);
				break;
		
			case 9:
				$this->setAuthView($value);
				break;
		
			case 10:
				$this->setAuthRead($value);
				break;
		
			case 11:
				$this->setAuthPost($value);
				break;
		
			case 12:
				$this->setAuthReply($value);
				break;
		
			case 13:
				$this->setAuthEdit($value);
				break;
		
			case 14:
				$this->setAuthDelete($value);
				break;
		
			case 15:
				$this->setAuthSticky($value);
				break;
		
			case 16:
				$this->setAuthAnnounce($value);
				break;
		
			case 17:
				$this->setAuthVote($value);
				break;
		
			case 18:
				$this->setAuthPollcreate($value);
				break;
		
			case 19:
				$this->setAuthAttatchment($value);
				break;
		
			case 20:
				$this->setCustomInfo($value);
				break;
		
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the (peer) column name (e.g.
	 * 'book.AUTHOR_ID')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = self::TYPE_COLNAME)
	{
		$keys = self::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);

		if (array_key_exists($keys[1], $arr)) $this->setCategoryId($arr[$keys[1]]);

		if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);

		if (array_key_exists($keys[3], $arr)) $this->setDescription($arr[$keys[3]]);

		if (array_key_exists($keys[4], $arr)) $this->setOrder($arr[$keys[4]]);

		if (array_key_exists($keys[5], $arr)) $this->setStatus($arr[$keys[5]]);

		if (array_key_exists($keys[6], $arr)) $this->setPosts($arr[$keys[6]]);

		if (array_key_exists($keys[7], $arr)) $this->setTopics($arr[$keys[7]]);

		if (array_key_exists($keys[8], $arr)) $this->setLastPoster($arr[$keys[8]]);

		if (array_key_exists($keys[9], $arr)) $this->setAuthView($arr[$keys[9]]);

		if (array_key_exists($keys[10], $arr)) $this->setAuthRead($arr[$keys[10]]);

		if (array_key_exists($keys[11], $arr)) $this->setAuthPost($arr[$keys[11]]);

		if (array_key_exists($keys[12], $arr)) $this->setAuthReply($arr[$keys[12]]);

		if (array_key_exists($keys[13], $arr)) $this->setAuthEdit($arr[$keys[13]]);

		if (array_key_exists($keys[14], $arr)) $this->setAuthDelete($arr[$keys[14]]);

		if (array_key_exists($keys[15], $arr)) $this->setAuthSticky($arr[$keys[15]]);

		if (array_key_exists($keys[16], $arr)) $this->setAuthAnnounce($arr[$keys[16]]);

		if (array_key_exists($keys[17], $arr)) $this->setAuthVote($arr[$keys[17]]);

		if (array_key_exists($keys[18], $arr)) $this->setAuthPollcreate($arr[$keys[18]]);

		if (array_key_exists($keys[19], $arr)) $this->setAuthAttatchment($arr[$keys[19]]);

		if (array_key_exists($keys[20], $arr)) $this->setCustomInfo($arr[$keys[20]]);

	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(ForumPeer::DATABASE_NAME);

		if ($this->isColumnModified(ForumPeer::ID)) $criteria->add(ForumPeer::ID, $this->id);

		if ($this->isColumnModified(ForumPeer::CATEGORY_ID)) $criteria->add(ForumPeer::CATEGORY_ID, $this->category_id);

		if ($this->isColumnModified(ForumPeer::NAME)) $criteria->add(ForumPeer::NAME, $this->name);

		if ($this->isColumnModified(ForumPeer::DESCRIPTION)) $criteria->add(ForumPeer::DESCRIPTION, $this->description);

		if ($this->isColumnModified(ForumPeer::ORDER)) $criteria->add(ForumPeer::ORDER, $this->order);

		if ($this->isColumnModified(ForumPeer::STATUS)) $criteria->add(ForumPeer::STATUS, $this->status);

		if ($this->isColumnModified(ForumPeer::POSTS)) $criteria->add(ForumPeer::POSTS, $this->posts);

		if ($this->isColumnModified(ForumPeer::TOPICS)) $criteria->add(ForumPeer::TOPICS, $this->topics);

		if ($this->isColumnModified(ForumPeer::LAST_POSTER)) $criteria->add(ForumPeer::LAST_POSTER, $this->last_poster);

		if ($this->isColumnModified(ForumPeer::AUTH_VIEW)) $criteria->add(ForumPeer::AUTH_VIEW, $this->auth_view);

		if ($this->isColumnModified(ForumPeer::AUTH_READ)) $criteria->add(ForumPeer::AUTH_READ, $this->auth_read);

		if ($this->isColumnModified(ForumPeer::AUTH_POST)) $criteria->add(ForumPeer::AUTH_POST, $this->auth_post);

		if ($this->isColumnModified(ForumPeer::AUTH_REPLY)) $criteria->add(ForumPeer::AUTH_REPLY, $this->auth_reply);

		if ($this->isColumnModified(ForumPeer::AUTH_EDIT)) $criteria->add(ForumPeer::AUTH_EDIT, $this->auth_edit);

		if ($this->isColumnModified(ForumPeer::AUTH_DELETE)) $criteria->add(ForumPeer::AUTH_DELETE, $this->auth_delete);

		if ($this->isColumnModified(ForumPeer::AUTH_STICKY)) $criteria->add(ForumPeer::AUTH_STICKY, $this->auth_sticky);

		if ($this->isColumnModified(ForumPeer::AUTH_ANNOUNCE)) $criteria->add(ForumPeer::AUTH_ANNOUNCE, $this->auth_announce);

		if ($this->isColumnModified(ForumPeer::AUTH_VOTE)) $criteria->add(ForumPeer::AUTH_VOTE, $this->auth_vote);

		if ($this->isColumnModified(ForumPeer::AUTH_POLLCREATE)) $criteria->add(ForumPeer::AUTH_POLLCREATE, $this->auth_pollcreate);

		if ($this->isColumnModified(ForumPeer::AUTH_ATTATCHMENT)) $criteria->add(ForumPeer::AUTH_ATTATCHMENT, $this->auth_attatchment);

		if ($this->isColumnModified(ForumPeer::CUSTOM_INFO)) $criteria->add(ForumPeer::CUSTOM_INFO, $this->custom_info);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(ForumPeer::DATABASE_NAME);

		$criteria->add(ForumPeer::ID, $this->id);

		$criteria->add(ForumPeer::CATEGORY_ID, $this->category_id);

		return $criteria;
	}

	/**
	 * Returns the composite primary key for this object.
	 * The array elements will be in same order as specified in XML.
	 * @return array
	 */
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getId();

		$pks[1] = $this->getCategoryId();

		return $pks;
	}

	/**
	 * Set the [composite] primary key.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 */
	public function setPrimaryKey($keys)
	{

		$this->setId($keys[0]);

		$this->setCategoryId($keys[1]);

	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Forum (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setName($this->name);

		$copyObj->setDescription($this->description);

		$copyObj->setOrder($this->order);

		$copyObj->setStatus($this->status);

		$copyObj->setPosts($this->posts);

		$copyObj->setTopics($this->topics);

		$copyObj->setLastPoster($this->last_poster);

		$copyObj->setAuthView($this->auth_view);

		$copyObj->setAuthRead($this->auth_read);

		$copyObj->setAuthPost($this->auth_post);

		$copyObj->setAuthReply($this->auth_reply);

		$copyObj->setAuthEdit($this->auth_edit);

		$copyObj->setAuthDelete($this->auth_delete);

		$copyObj->setAuthSticky($this->auth_sticky);

		$copyObj->setAuthAnnounce($this->auth_announce);

		$copyObj->setAuthVote($this->auth_vote);

		$copyObj->setAuthPollcreate($this->auth_pollcreate);

		$copyObj->setAuthAttatchment($this->auth_attatchment);

		$copyObj->setCustomInfo($this->custom_info);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTopics() as $relObj) {
				$copyObj->addTopic($relObj->copy());
			}

			foreach($this->getPosts() as $relObj) {
				$copyObj->addPost($relObj->copy());
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

		$copyObj->setCategoryId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Forum Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * 
	 * @return ForumPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ForumPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Category object.
	 *
	 * @param Category $v
	 * @return void
	 * @throws PropelException
	 */
	public function setCategory($v)
	{


		if ($v === null) {
			$this->setCategoryId(NULL);
		} else {
			$this->setCategoryId($v->getId());
		}


		$this->aCategory = $v;
	}


	/**
	 * Get the associated Category object
	 *
	 * @param Connection Optional Connection object.
	 * @return Category The associated Category object.
	 * @throws PropelException
	 */
	public function getCategory($con = null)
	{
		// include the related Peer class
		include_once 'model/om/BaseCategoryPeer.php';

		if ($this->aCategory === null && ($this->category_id !== null)) {

			$this->aCategory = CategoryPeer::retrieveByPK($this->category_id, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = CategoryPeer::retrieveByPK($this->category_id, $con);
			   $obj->addCategorys($this);
			 */
		}
		return $this->aCategory;
	}

	/**
	 * Declares an association between this object and a User object.
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{


		if ($v === null) {
			$this->setLastPoster(NULL);
		} else {
			$this->setLastPoster($v->getId());
		}


		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the related Peer class
		include_once 'model/om/BaseUserPeer.php';

		if ($this->aUser === null && ($this->last_poster !== null)) {

			$this->aUser = UserPeer::retrieveByPK($this->last_poster, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->last_poster, $con);
			   $obj->addUsers($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Temporary storage of collTopics to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTopics()
	{
		if ($this->collTopics === null) {
			$this->collTopics = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum has previously
	 * been saved, it will retrieve related Topics from storage.
	 * If this Forum is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTopics($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseTopicPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collTopics === null) {
			if ($this->isNew()) {
			   $this->collTopics = array();
			} else {

				$criteria->add(TopicPeer::FORUM_ID, $this->getId());

				TopicPeer::addSelectColumns($criteria);
				$this->collTopics = TopicPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TopicPeer::FORUM_ID, $this->getId());

				TopicPeer::addSelectColumns($criteria);
				if (!isset($this->lastTopicCriteria) || !$this->lastTopicCriteria->equals($criteria)) {
					$this->collTopics = TopicPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTopicCriteria = $criteria;
		return $this->collTopics;
	}

	/**
	 * Returns the number of related Topics.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countTopics($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseTopicPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(TopicPeer::FORUM_ID, $this->getId());

		return TopicPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Topic object to this object
	 * through the Topic foreign key attribute
	 *
	 * @param Topic $l Topic
	 * @return void
	 * @throws PropelException
	 */
	public function addTopic(Topic $l)
	{
		$this->collTopics[] = $l;
		$l->setForum($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum is new, it will return
	 * an empty collection; or if this Forum has previously
	 * been saved, it will retrieve related Topics from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Forum.
	 */
	public function getTopicsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseTopicPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collTopics === null) {
			if ($this->isNew()) {
				$this->collTopics = array();
			} else {

				$criteria->add(TopicPeer::FORUM_ID, $this->getId());

				$this->collTopics = TopicPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TopicPeer::FORUM_ID, $this->getId());

			if (!isset($this->lastTopicCriteria) || !$this->lastTopicCriteria->equals($criteria)) {
				$this->collTopics = TopicPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastTopicCriteria = $criteria;

		return $this->collTopics;
	}

	/**
	 * Temporary storage of collPosts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPosts()
	{
		if ($this->collPosts === null) {
			$this->collPosts = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum has previously
	 * been saved, it will retrieve related Posts from storage.
	 * If this Forum is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPosts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
			   $this->collPosts = array();
			} else {

				$criteria->add(PostPeer::FORUM_ID, $this->getId());

				PostPeer::addSelectColumns($criteria);
				$this->collPosts = PostPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(PostPeer::FORUM_ID, $this->getId());

				PostPeer::addSelectColumns($criteria);
				if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
					$this->collPosts = PostPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPostCriteria = $criteria;
		return $this->collPosts;
	}

	/**
	 * Returns the number of related Posts.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countPosts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(PostPeer::FORUM_ID, $this->getId());

		return PostPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Post object to this object
	 * through the Post foreign key attribute
	 *
	 * @param Post $l Post
	 * @return void
	 * @throws PropelException
	 */
	public function addPost(Post $l)
	{
		$this->collPosts[] = $l;
		$l->setForum($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum is new, it will return
	 * an empty collection; or if this Forum has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Forum.
	 */
	public function getPostsJoinTopic($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::FORUM_ID, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinTopic($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::FORUM_ID, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinTopic($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum is new, it will return
	 * an empty collection; or if this Forum has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Forum.
	 */
	public function getPostsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::FORUM_ID, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::FORUM_ID, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Forum is new, it will return
	 * an empty collection; or if this Forum has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Forum.
	 */
	public function getPostsJoinPostRelatedByReplyOf($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::FORUM_ID, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinPostRelatedByReplyOf($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::FORUM_ID, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinPostRelatedByReplyOf($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}

} // BaseForum
