<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'model/PagePeer.php';

/**
 * Base class that represents a row from the 'page' table.
 *
 * 
 *
 * @package model.om
 */	
abstract class BasePage extends BaseObject  implements Persistent {


	/**
	 * phpname type
	 * e.g. 'AuthorId'
	 */
	const TYPE_PHPNAME = 'phpName';

	/**
	 * column (peer) name type
	 * e.g. 'book.AUTHOR_ID'
	 */
	const TYPE_COLNAME = 'colName';

	/**
	 * column fieldname type
	 * e.g. 'author_id'
	 */
	const TYPE_FIELDNAME = 'fieldName';

	/**
	 * num type
	 * simply the numerical array index, e.g. 4
	 */
	const TYPE_NUM = 'num';

	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var PagePeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var int
	 */
	protected $id;


	/**
	 * The value for the title field.
	 * @var string
	 */
	protected $title;


	/**
	 * The value for the text field.
	 * @var string
	 */
	protected $text;


	/**
	 * The value for the auth_read field.
	 * @var int
	 */
	protected $auth_read;


	/**
	 * The value for the auth_edit field.
	 * @var int
	 */
	protected $auth_edit;


	/**
	 * The value for the auth_delete field.
	 * @var int
	 */
	protected $auth_delete;


	/**
	 * The value for the auth_attatchment field.
	 * @var int
	 */
	protected $auth_attatchment;


	/**
	 * The value for the custom_info field.
	 * @var string
	 */
	protected $custom_info;

	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		Page::TYPE_PHPNAME => array ('Id', 'Title', 'Text', 'AuthRead', 'AuthEdit', 'AuthDelete', 'AuthAttatchment', 'CustomInfo', ),
		Page::TYPE_COLNAME => array (PagePeer::ID, PagePeer::TITLE, PagePeer::TEXT, PagePeer::AUTH_READ, PagePeer::AUTH_EDIT, PagePeer::AUTH_DELETE, PagePeer::AUTH_ATTATCHMENT, PagePeer::CUSTOM_INFO, ),
		
		Page::TYPE_FIELDNAME => array ('id', 'title', 'text', 'auth_read', 'auth_edit', 'auth_delete', 'auth_attatchment', 'custom_info', ),
		
		Page::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		Page::TYPE_PHPNAME => array ('Id' => 0, 'Title' => 1, 'Text' => 2, 'AuthRead' => 3, 'AuthEdit' => 4, 'AuthDelete' => 5, 'AuthAttatchment' => 6, 'CustomInfo' => 7, ),
		Page::TYPE_COLNAME => array (PagePeer::ID => 0, PagePeer::TITLE => 1, PagePeer::TEXT => 2, PagePeer::AUTH_READ => 3, PagePeer::AUTH_EDIT => 4, PagePeer::AUTH_DELETE => 5, PagePeer::AUTH_ATTATCHMENT => 6, PagePeer::CUSTOM_INFO => 7, ),
		
		Page::TYPE_FIELDNAME => array ('id' => 0, 'title' => 1, 'text' => 2, 'auth_read' => 3, 'auth_edit' => 4, 'auth_delete' => 5, 'auth_attatchment' => 6, 'custom_info' => 7, ),
		
		Page::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, )
	);

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [title] column value.
	 * 
	 * @return string
	 */
	public function getTitle()
	{

		return $this->title;
	}

	/**
	 * Get the [text] column value.
	 * 
	 * @return string
	 */
	public function getText()
	{

		return $this->text;
	}

	/**
	 * Get the [auth_read] column value.
	 * 
	 * @return int
	 */
	public function getAuthRead()
	{

		return $this->auth_read;
	}

	/**
	 * Get the [auth_edit] column value.
	 * 
	 * @return int
	 */
	public function getAuthEdit()
	{

		return $this->auth_edit;
	}

	/**
	 * Get the [auth_delete] column value.
	 * 
	 * @return int
	 */
	public function getAuthDelete()
	{

		return $this->auth_delete;
	}

	/**
	 * Get the [auth_attatchment] column value.
	 * 
	 * @return int
	 */
	public function getAuthAttatchment()
	{

		return $this->auth_attatchment;
	}

	/**
	 * Get the [custom_info] column value.
	 * 
	 * @return string
	 */
	public function getCustomInfo()
	{

		return $this->custom_info;
	}

	/**
	 * Set the value of [id] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setId($v)
	{

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = PagePeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [title] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setTitle($v)
	{

		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = PagePeer::TITLE;
		}

	} // setTitle()

	/**
	 * Set the value of [text] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setText($v)
	{

		if ($this->text !== $v) {
			$this->text = $v;
			$this->modifiedColumns[] = PagePeer::TEXT;
		}

	} // setText()

	/**
	 * Set the value of [auth_read] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthRead($v)
	{

		if ($this->auth_read !== $v) {
			$this->auth_read = $v;
			$this->modifiedColumns[] = PagePeer::AUTH_READ;
		}

	} // setAuthRead()

	/**
	 * Set the value of [auth_edit] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthEdit($v)
	{

		if ($this->auth_edit !== $v) {
			$this->auth_edit = $v;
			$this->modifiedColumns[] = PagePeer::AUTH_EDIT;
		}

	} // setAuthEdit()

	/**
	 * Set the value of [auth_delete] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthDelete($v)
	{

		if ($this->auth_delete !== $v) {
			$this->auth_delete = $v;
			$this->modifiedColumns[] = PagePeer::AUTH_DELETE;
		}

	} // setAuthDelete()

	/**
	 * Set the value of [auth_attatchment] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setAuthAttatchment($v)
	{

		if ($this->auth_attatchment !== $v) {
			$this->auth_attatchment = $v;
			$this->modifiedColumns[] = PagePeer::AUTH_ATTATCHMENT;
		}

	} // setAuthAttatchment()

	/**
	 * Set the value of [custom_info] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setCustomInfo($v)
	{

		if ($this->custom_info !== $v) {
			$this->custom_info = $v;
			$this->modifiedColumns[] = PagePeer::CUSTOM_INFO;
		}

	} // setCustomInfo()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->title = $rs->getString($startcol + 1);

			$this->text = $rs->getString($startcol + 2);

			$this->auth_read = $rs->getInt($startcol + 3);

			$this->auth_edit = $rs->getInt($startcol + 4);

			$this->auth_delete = $rs->getInt($startcol + 5);

			$this->auth_attatchment = $rs->getInt($startcol + 6);

			$this->custom_info = $rs->getString($startcol + 7);

			$this->resetModified();

			$this->setNew(false);
						
			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 8; // 8 = PagePeer::NUM_COLUMNS - PagePeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Page object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PagePeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			PagePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(PagePeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PagePeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += PagePeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 * @see doValidate()
	 */
	public function validate($columns = null)
	{
	  if ($columns) {
		return PagePeer::doValidate($this, $columns);
	  }
		return $this->doValidate();
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = PagePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Translates a fieldname to another type
	 *
	 * @param string $name field name
	 * @param string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param string $toType   One of the class type constants
	 * @return string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = self::$fieldKeys[$fromType][$name];
		if ($key === false) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r($fromNames, true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param  string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return array A list of field names
	 */

	static public function getFieldNames($type = self::TYPE_FIELDNAME)
	{
		if (!isset(self::$fieldNames[$type])) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = self::TYPE_COLNAME)
	{
		$names = self::getFieldNames($type);
		$pos = self::translateFieldName($name, $type, self::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {

			case 0:
				return $this->getId();
				break;

			case 1:
				return $this->getTitle();
				break;

			case 2:
				return $this->getText();
				break;

			case 3:
				return $this->getAuthRead();
				break;

			case 4:
				return $this->getAuthEdit();
				break;

			case 5:
				return $this->getAuthDelete();
				break;

			case 6:
				return $this->getAuthAttatchment();
				break;

			case 7:
				return $this->getCustomInfo();
				break;

			default:
				return null;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = self::TYPE_PHPNAME)
	{
		$keys = self::getFieldNames($keyType);
		$result = array(

			$keys[0] => $this->getId(),

			$keys[1] => $this->getTitle(),

			$keys[2] => $this->getText(),

			$keys[3] => $this->getAuthRead(),

			$keys[4] => $this->getAuthEdit(),

			$keys[5] => $this->getAuthDelete(),

			$keys[6] => $this->getAuthAttatchment(),

			$keys[7] => $this->getCustomInfo(),

		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = self::TYPE_COLNAME)
	{
		$names = $this->getFieldnames($type);
		$pos = array_search($name, $names);
		return $this->setByPosition($pos, $name);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {

			case 0:
				$this->setId($value);
				break;
		
			case 1:
				$this->setTitle($value);
				break;
		
			case 2:
				$this->setText($value);
				break;
		
			case 3:
				$this->setAuthRead($value);
				break;
		
			case 4:
				$this->setAuthEdit($value);
				break;
		
			case 5:
				$this->setAuthDelete($value);
				break;
		
			case 6:
				$this->setAuthAttatchment($value);
				break;
		
			case 7:
				$this->setCustomInfo($value);
				break;
		
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the (peer) column name (e.g.
	 * 'book.AUTHOR_ID')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = self::TYPE_COLNAME)
	{
		$keys = self::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);

		if (array_key_exists($keys[1], $arr)) $this->setTitle($arr[$keys[1]]);

		if (array_key_exists($keys[2], $arr)) $this->setText($arr[$keys[2]]);

		if (array_key_exists($keys[3], $arr)) $this->setAuthRead($arr[$keys[3]]);

		if (array_key_exists($keys[4], $arr)) $this->setAuthEdit($arr[$keys[4]]);

		if (array_key_exists($keys[5], $arr)) $this->setAuthDelete($arr[$keys[5]]);

		if (array_key_exists($keys[6], $arr)) $this->setAuthAttatchment($arr[$keys[6]]);

		if (array_key_exists($keys[7], $arr)) $this->setCustomInfo($arr[$keys[7]]);

	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(PagePeer::DATABASE_NAME);

		if ($this->isColumnModified(PagePeer::ID)) $criteria->add(PagePeer::ID, $this->id);

		if ($this->isColumnModified(PagePeer::TITLE)) $criteria->add(PagePeer::TITLE, $this->title);

		if ($this->isColumnModified(PagePeer::TEXT)) $criteria->add(PagePeer::TEXT, $this->text);

		if ($this->isColumnModified(PagePeer::AUTH_READ)) $criteria->add(PagePeer::AUTH_READ, $this->auth_read);

		if ($this->isColumnModified(PagePeer::AUTH_EDIT)) $criteria->add(PagePeer::AUTH_EDIT, $this->auth_edit);

		if ($this->isColumnModified(PagePeer::AUTH_DELETE)) $criteria->add(PagePeer::AUTH_DELETE, $this->auth_delete);

		if ($this->isColumnModified(PagePeer::AUTH_ATTATCHMENT)) $criteria->add(PagePeer::AUTH_ATTATCHMENT, $this->auth_attatchment);

		if ($this->isColumnModified(PagePeer::CUSTOM_INFO)) $criteria->add(PagePeer::CUSTOM_INFO, $this->custom_info);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(PagePeer::DATABASE_NAME);

		$criteria->add(PagePeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int 
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Page (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setTitle($this->title);

		$copyObj->setText($this->text);

		$copyObj->setAuthRead($this->auth_read);

		$copyObj->setAuthEdit($this->auth_edit);

		$copyObj->setAuthDelete($this->auth_delete);

		$copyObj->setAuthAttatchment($this->auth_attatchment);

		$copyObj->setCustomInfo($this->custom_info);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Page Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * 
	 * @return PagePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PagePeer();
		}
		return self::$peer;
	}

} // BasePage
