<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'model/TopicPeer.php';

/**
 * Base class that represents a row from the 'topic' table.
 *
 * 
 *
 * @package model.om
 */	
abstract class BaseTopic extends BaseObject  implements Persistent {


	/**
	 * phpname type
	 * e.g. 'AuthorId'
	 */
	const TYPE_PHPNAME = 'phpName';

	/**
	 * column (peer) name type
	 * e.g. 'book.AUTHOR_ID'
	 */
	const TYPE_COLNAME = 'colName';

	/**
	 * column fieldname type
	 * e.g. 'author_id'
	 */
	const TYPE_FIELDNAME = 'fieldName';

	/**
	 * num type
	 * simply the numerical array index, e.g. 4
	 */
	const TYPE_NUM = 'num';

	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TopicPeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var int
	 */
	protected $id;


	/**
	 * The value for the forum_id field.
	 * @var int
	 */
	protected $forum_id;


	/**
	 * The value for the title field.
	 * @var string
	 */
	protected $title;


	/**
	 * The value for the poster field.
	 * @var int
	 */
	protected $poster;


	/**
	 * The value for the poster_username field.
	 * @var string
	 */
	protected $poster_username;


	/**
	 * The value for the created_at field.
	 * @var int
	 */
	protected $created_at;


	/**
	 * The value for the updated_at field.
	 * @var int
	 */
	protected $updated_at;


	/**
	 * The value for the views field.
	 * @var int
	 */
	protected $views;


	/**
	 * The value for the replies field.
	 * @var int
	 */
	protected $replies;


	/**
	 * The value for the type field.
	 * @var int
	 */
	protected $type;


	/**
	 * The value for the custom_info field.
	 * @var string
	 */
	protected $custom_info;

	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		Topic::TYPE_PHPNAME => array ('Id', 'ForumId', 'Title', 'Poster', 'PosterUsername', 'CreatedAt', 'UpdatedAt', 'Views', 'Replies', 'Type', 'CustomInfo', ),
		Topic::TYPE_COLNAME => array (TopicPeer::ID, TopicPeer::FORUM_ID, TopicPeer::TITLE, TopicPeer::POSTER, TopicPeer::POSTER_USERNAME, TopicPeer::CREATED_AT, TopicPeer::UPDATED_AT, TopicPeer::VIEWS, TopicPeer::REPLIES, TopicPeer::TYPE, TopicPeer::CUSTOM_INFO, ),
		
		Topic::TYPE_FIELDNAME => array ('id', 'forum_id', 'title', 'poster', 'poster_username', 'created_at', 'updated_at', 'views', 'replies', 'type', 'custom_info', ),
		
		Topic::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		Topic::TYPE_PHPNAME => array ('Id' => 0, 'ForumId' => 1, 'Title' => 2, 'Poster' => 3, 'PosterUsername' => 4, 'CreatedAt' => 5, 'UpdatedAt' => 6, 'Views' => 7, 'Replies' => 8, 'Type' => 9, 'CustomInfo' => 10, ),
		Topic::TYPE_COLNAME => array (TopicPeer::ID => 0, TopicPeer::FORUM_ID => 1, TopicPeer::TITLE => 2, TopicPeer::POSTER => 3, TopicPeer::POSTER_USERNAME => 4, TopicPeer::CREATED_AT => 5, TopicPeer::UPDATED_AT => 6, TopicPeer::VIEWS => 7, TopicPeer::REPLIES => 8, TopicPeer::TYPE => 9, TopicPeer::CUSTOM_INFO => 10, ),
		
		Topic::TYPE_FIELDNAME => array ('id' => 0, 'forum_id' => 1, 'title' => 2, 'poster' => 3, 'poster_username' => 4, 'created_at' => 5, 'updated_at' => 6, 'views' => 7, 'replies' => 8, 'type' => 9, 'custom_info' => 10, ),
		
		Topic::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, )
	);

	/**
	 * @var Forum
	 */
	protected $aForum;

	/**
	 * @var User
	 */
	protected $aUser;

	/**
	 * Collection to store aggregation of collPosts.
	 * @var array
	 */
	protected $collPosts;
	
	/**
	 * The criteria used to select the current contents of collPosts.
	 * @var Criteria
	 */
	private $lastPostCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [forum_id] column value.
	 * 
	 * @return int
	 */
	public function getForumId()
	{

		return $this->forum_id;
	}

	/**
	 * Get the [title] column value.
	 * 
	 * @return string
	 */
	public function getTitle()
	{

		return $this->title;
	}

	/**
	 * Get the [poster] column value.
	 * 
	 * @return int
	 */
	public function getPoster()
	{

		return $this->poster;
	}

	/**
	 * Get the [poster_username] column value.
	 * 
	 * @return string
	 */
	public function getPosterUsername()
	{

		return $this->poster_username;
	}

	/**
	 * Get the [optionally formatted] [created_at] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->created_at);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [updated_at] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->updated_at === null || $this->updated_at === '') {
			return null;
		} elseif (!is_int($this->updated_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->updated_at);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of [updated_at] as date/time value: " . var_export($this->updated_at, true));
			}
		} else {
			$ts = $this->updated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [views] column value.
	 * 
	 * @return int
	 */
	public function getViews()
	{

		return $this->views;
	}

	/**
	 * Get the [replies] column value.
	 * 
	 * @return int
	 */
	public function getReplies()
	{

		return $this->replies;
	}

	/**
	 * Get the [type] column value.
	 * 
	 * @return int
	 */
	public function getType()
	{

		return $this->type;
	}

	/**
	 * Get the [custom_info] column value.
	 * 
	 * @return string
	 */
	public function getCustomInfo()
	{

		return $this->custom_info;
	}

	/**
	 * Set the value of [id] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setId($v)
	{

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = TopicPeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [forum_id] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setForumId($v)
	{

		if ($this->forum_id !== $v) {
			$this->forum_id = $v;
			$this->modifiedColumns[] = TopicPeer::FORUM_ID;
		}

		if ($this->aForum !== null && $this->aForum->getId() !== $v) {
			$this->aForum = null;
		}		

	} // setForumId()

	/**
	 * Set the value of [title] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setTitle($v)
	{

		if ($this->title !== $v) {
			$this->title = $v;
			$this->modifiedColumns[] = TopicPeer::TITLE;
		}

	} // setTitle()

	/**
	 * Set the value of [poster] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setPoster($v)
	{

		if ($this->poster !== $v) {
			$this->poster = $v;
			$this->modifiedColumns[] = TopicPeer::POSTER;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}		

	} // setPoster()

	/**
	 * Set the value of [poster_username] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setPosterUsername($v)
	{

		if ($this->poster_username !== $v) {
			$this->poster_username = $v;
			$this->modifiedColumns[] = TopicPeer::POSTER_USERNAME;
		}

	} // setPosterUsername()

	/**
	 * Set the value of [created_at] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = TopicPeer::CREATED_AT;
		}

	} // setCreatedAt()

	/**
	 * Set the value of [updated_at] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUpdatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for [updated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->updated_at !== $ts) {
			$this->updated_at = $ts;
			$this->modifiedColumns[] = TopicPeer::UPDATED_AT;
		}

	} // setUpdatedAt()

	/**
	 * Set the value of [views] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setViews($v)
	{

		if ($this->views !== $v) {
			$this->views = $v;
			$this->modifiedColumns[] = TopicPeer::VIEWS;
		}

	} // setViews()

	/**
	 * Set the value of [replies] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setReplies($v)
	{

		if ($this->replies !== $v) {
			$this->replies = $v;
			$this->modifiedColumns[] = TopicPeer::REPLIES;
		}

	} // setReplies()

	/**
	 * Set the value of [type] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setType($v)
	{

		if ($this->type !== $v) {
			$this->type = $v;
			$this->modifiedColumns[] = TopicPeer::TYPE;
		}

	} // setType()

	/**
	 * Set the value of [custom_info] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setCustomInfo($v)
	{

		if ($this->custom_info !== $v) {
			$this->custom_info = $v;
			$this->modifiedColumns[] = TopicPeer::CUSTOM_INFO;
		}

	} // setCustomInfo()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->forum_id = $rs->getInt($startcol + 1);

			$this->title = $rs->getString($startcol + 2);

			$this->poster = $rs->getInt($startcol + 3);

			$this->poster_username = $rs->getString($startcol + 4);

			$this->created_at = $rs->getTimestamp($startcol + 5, null);

			$this->updated_at = $rs->getTimestamp($startcol + 6, null);

			$this->views = $rs->getInt($startcol + 7);

			$this->replies = $rs->getInt($startcol + 8);

			$this->type = $rs->getInt($startcol + 9);

			$this->custom_info = $rs->getString($startcol + 10);

			$this->resetModified();

			$this->setNew(false);
						
			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 11; // 11 = TopicPeer::NUM_COLUMNS - TopicPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating Topic object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TopicPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			TopicPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(TopicPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aForum !== null) {
				if ($this->aForum->isModified()) {
					$affectedRows += $this->aForum->save($con);
				}
				$this->setForum($this->aForum);
			}

			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TopicPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += TopicPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collPosts !== null) {
				foreach($this->collPosts as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 * @see doValidate()
	 */
	public function validate($columns = null)
	{
	  if ($columns) {
		return TopicPeer::doValidate($this, $columns);
	  }
		return $this->doValidate();
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aForum !== null) {
				if (($retval = $this->aForum->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}


			if (($retval = TopicPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collPosts !== null) {
					foreach($this->collPosts as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Translates a fieldname to another type
	 *
	 * @param string $name field name
	 * @param string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param string $toType   One of the class type constants
	 * @return string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = self::$fieldKeys[$fromType][$name];
		if ($key === false) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r($fromNames, true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param  string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return array A list of field names
	 */

	static public function getFieldNames($type = self::TYPE_FIELDNAME)
	{
		if (!isset(self::$fieldNames[$type])) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = self::TYPE_COLNAME)
	{
		$names = self::getFieldNames($type);
		$pos = self::translateFieldName($name, $type, self::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {

			case 0:
				return $this->getId();
				break;

			case 1:
				return $this->getForumId();
				break;

			case 2:
				return $this->getTitle();
				break;

			case 3:
				return $this->getPoster();
				break;

			case 4:
				return $this->getPosterUsername();
				break;

			case 5:
				return $this->getCreatedAt();
				break;

			case 6:
				return $this->getUpdatedAt();
				break;

			case 7:
				return $this->getViews();
				break;

			case 8:
				return $this->getReplies();
				break;

			case 9:
				return $this->getType();
				break;

			case 10:
				return $this->getCustomInfo();
				break;

			default:
				return null;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = self::TYPE_PHPNAME)
	{
		$keys = self::getFieldNames($keyType);
		$result = array(

			$keys[0] => $this->getId(),

			$keys[1] => $this->getForumId(),

			$keys[2] => $this->getTitle(),

			$keys[3] => $this->getPoster(),

			$keys[4] => $this->getPosterUsername(),

			$keys[5] => $this->getCreatedAt(),

			$keys[6] => $this->getUpdatedAt(),

			$keys[7] => $this->getViews(),

			$keys[8] => $this->getReplies(),

			$keys[9] => $this->getType(),

			$keys[10] => $this->getCustomInfo(),

		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = self::TYPE_COLNAME)
	{
		$names = $this->getFieldnames($type);
		$pos = array_search($name, $names);
		return $this->setByPosition($pos, $name);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {

			case 0:
				$this->setId($value);
				break;
		
			case 1:
				$this->setForumId($value);
				break;
		
			case 2:
				$this->setTitle($value);
				break;
		
			case 3:
				$this->setPoster($value);
				break;
		
			case 4:
				$this->setPosterUsername($value);
				break;
		
			case 5:
				$this->setCreatedAt($value);
				break;
		
			case 6:
				$this->setUpdatedAt($value);
				break;
		
			case 7:
				$this->setViews($value);
				break;
		
			case 8:
				$this->setReplies($value);
				break;
		
			case 9:
				$this->setType($value);
				break;
		
			case 10:
				$this->setCustomInfo($value);
				break;
		
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the (peer) column name (e.g.
	 * 'book.AUTHOR_ID')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = self::TYPE_COLNAME)
	{
		$keys = self::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);

		if (array_key_exists($keys[1], $arr)) $this->setForumId($arr[$keys[1]]);

		if (array_key_exists($keys[2], $arr)) $this->setTitle($arr[$keys[2]]);

		if (array_key_exists($keys[3], $arr)) $this->setPoster($arr[$keys[3]]);

		if (array_key_exists($keys[4], $arr)) $this->setPosterUsername($arr[$keys[4]]);

		if (array_key_exists($keys[5], $arr)) $this->setCreatedAt($arr[$keys[5]]);

		if (array_key_exists($keys[6], $arr)) $this->setUpdatedAt($arr[$keys[6]]);

		if (array_key_exists($keys[7], $arr)) $this->setViews($arr[$keys[7]]);

		if (array_key_exists($keys[8], $arr)) $this->setReplies($arr[$keys[8]]);

		if (array_key_exists($keys[9], $arr)) $this->setType($arr[$keys[9]]);

		if (array_key_exists($keys[10], $arr)) $this->setCustomInfo($arr[$keys[10]]);

	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(TopicPeer::DATABASE_NAME);

		if ($this->isColumnModified(TopicPeer::ID)) $criteria->add(TopicPeer::ID, $this->id);

		if ($this->isColumnModified(TopicPeer::FORUM_ID)) $criteria->add(TopicPeer::FORUM_ID, $this->forum_id);

		if ($this->isColumnModified(TopicPeer::TITLE)) $criteria->add(TopicPeer::TITLE, $this->title);

		if ($this->isColumnModified(TopicPeer::POSTER)) $criteria->add(TopicPeer::POSTER, $this->poster);

		if ($this->isColumnModified(TopicPeer::POSTER_USERNAME)) $criteria->add(TopicPeer::POSTER_USERNAME, $this->poster_username);

		if ($this->isColumnModified(TopicPeer::CREATED_AT)) $criteria->add(TopicPeer::CREATED_AT, $this->created_at);

		if ($this->isColumnModified(TopicPeer::UPDATED_AT)) $criteria->add(TopicPeer::UPDATED_AT, $this->updated_at);

		if ($this->isColumnModified(TopicPeer::VIEWS)) $criteria->add(TopicPeer::VIEWS, $this->views);

		if ($this->isColumnModified(TopicPeer::REPLIES)) $criteria->add(TopicPeer::REPLIES, $this->replies);

		if ($this->isColumnModified(TopicPeer::TYPE)) $criteria->add(TopicPeer::TYPE, $this->type);

		if ($this->isColumnModified(TopicPeer::CUSTOM_INFO)) $criteria->add(TopicPeer::CUSTOM_INFO, $this->custom_info);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(TopicPeer::DATABASE_NAME);

		$criteria->add(TopicPeer::ID, $this->id);

		$criteria->add(TopicPeer::FORUM_ID, $this->forum_id);

		return $criteria;
	}

	/**
	 * Returns the composite primary key for this object.
	 * The array elements will be in same order as specified in XML.
	 * @return array
	 */
	public function getPrimaryKey()
	{
		$pks = array();

		$pks[0] = $this->getId();

		$pks[1] = $this->getForumId();

		return $pks;
	}

	/**
	 * Set the [composite] primary key.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 */
	public function setPrimaryKey($keys)
	{

		$this->setId($keys[0]);

		$this->setForumId($keys[1]);

	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of Topic (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setTitle($this->title);

		$copyObj->setPoster($this->poster);

		$copyObj->setPosterUsername($this->poster_username);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);

		$copyObj->setViews($this->views);

		$copyObj->setReplies($this->replies);

		$copyObj->setType($this->type);

		$copyObj->setCustomInfo($this->custom_info);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getPosts() as $relObj) {
				$copyObj->addPost($relObj->copy());
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

		$copyObj->setForumId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return Topic Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * 
	 * @return TopicPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TopicPeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a Forum object.
	 *
	 * @param Forum $v
	 * @return void
	 * @throws PropelException
	 */
	public function setForum($v)
	{


		if ($v === null) {
			$this->setForumId(NULL);
		} else {
			$this->setForumId($v->getId());
		}


		$this->aForum = $v;
	}


	/**
	 * Get the associated Forum object
	 *
	 * @param Connection Optional Connection object.
	 * @return Forum The associated Forum object.
	 * @throws PropelException
	 */
	public function getForum($con = null)
	{
		// include the related Peer class
		include_once 'model/om/BaseForumPeer.php';

		if ($this->aForum === null && ($this->forum_id !== null)) {

			$this->aForum = ForumPeer::retrieveByPK($this->forum_id, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ForumPeer::retrieveByPK($this->forum_id, $con);
			   $obj->addForums($this);
			 */
		}
		return $this->aForum;
	}

	/**
	 * Declares an association between this object and a User object.
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{


		if ($v === null) {
			$this->setPoster(NULL);
		} else {
			$this->setPoster($v->getId());
		}


		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the related Peer class
		include_once 'model/om/BaseUserPeer.php';

		if ($this->aUser === null && ($this->poster !== null)) {

			$this->aUser = UserPeer::retrieveByPK($this->poster, $con);
					
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->poster, $con);
			   $obj->addUsers($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Temporary storage of collPosts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPosts()
	{
		if ($this->collPosts === null) {
			$this->collPosts = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Topic has previously
	 * been saved, it will retrieve related Posts from storage.
	 * If this Topic is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPosts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
			   $this->collPosts = array();
			} else {

				$criteria->add(PostPeer::TOPIC_ID, $this->getId());

				PostPeer::addSelectColumns($criteria);
				$this->collPosts = PostPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(PostPeer::TOPIC_ID, $this->getId());

				PostPeer::addSelectColumns($criteria);
				if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
					$this->collPosts = PostPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPostCriteria = $criteria;
		return $this->collPosts;
	}

	/**
	 * Returns the number of related Posts.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countPosts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(PostPeer::TOPIC_ID, $this->getId());

		return PostPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Post object to this object
	 * through the Post foreign key attribute
	 *
	 * @param Post $l Post
	 * @return void
	 * @throws PropelException
	 */
	public function addPost(Post $l)
	{
		$this->collPosts[] = $l;
		$l->setTopic($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Topic is new, it will return
	 * an empty collection; or if this Topic has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Topic.
	 */
	public function getPostsJoinForum($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::TOPIC_ID, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinForum($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::TOPIC_ID, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinForum($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Topic is new, it will return
	 * an empty collection; or if this Topic has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Topic.
	 */
	public function getPostsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::TOPIC_ID, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::TOPIC_ID, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Topic is new, it will return
	 * an empty collection; or if this Topic has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Topic.
	 */
	public function getPostsJoinPostRelatedByReplyOf($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::TOPIC_ID, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinPostRelatedByReplyOf($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::TOPIC_ID, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinPostRelatedByReplyOf($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}

} // BaseTopic
