<?php

require_once 'propel/om/BaseObject.php';

require_once 'propel/om/Persistent.php';


include_once 'propel/util/Criteria.php';

include_once 'model/UserPeer.php';

/**
 * Base class that represents a row from the 'user' table.
 *
 * 
 *
 * @package model.om
 */	
abstract class BaseUser extends BaseObject  implements Persistent {


	/**
	 * phpname type
	 * e.g. 'AuthorId'
	 */
	const TYPE_PHPNAME = 'phpName';

	/**
	 * column (peer) name type
	 * e.g. 'book.AUTHOR_ID'
	 */
	const TYPE_COLNAME = 'colName';

	/**
	 * column fieldname type
	 * e.g. 'author_id'
	 */
	const TYPE_FIELDNAME = 'fieldName';

	/**
	 * num type
	 * simply the numerical array index, e.g. 4
	 */
	const TYPE_NUM = 'num';

	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UserPeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var int
	 */
	protected $id;


	/**
	 * The value for the username field.
	 * @var string
	 */
	protected $username;


	/**
	 * The value for the password field.
	 * @var string
	 */
	protected $password;


	/**
	 * The value for the last_login field.
	 * @var int
	 */
	protected $last_login;


	/**
	 * The value for the reg_date field.
	 * @var int
	 */
	protected $reg_date;


	/**
	 * The value for the level field.
	 * @var int
	 */
	protected $level;


	/**
	 * The value for the enabled field.
	 * @var boolean
	 */
	protected $enabled;


	/**
	 * The value for the posts field.
	 * @var int
	 */
	protected $posts;


	/**
	 * The value for the comments field.
	 * @var int
	 */
	protected $comments;


	/**
	 * The value for the timezone field.
	 * @var int
	 */
	protected $timezone;


	/**
	 * The value for the language field.
	 * @var string
	 */
	protected $language;


	/**
	 * The value for the new_msg field.
	 * @var int
	 */
	protected $new_msg;


	/**
	 * The value for the unread_msg field.
	 * @var int
	 */
	protected $unread_msg;


	/**
	 * The value for the email field.
	 * @var string
	 */
	protected $email;


	/**
	 * The value for the signiture field.
	 * @var string
	 */
	protected $signiture;


	/**
	 * The value for the custom_info field.
	 * @var string
	 */
	protected $custom_info;

	/**
	 * holds an array of fieldnames
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME][0] = 'Id'
	 */
	private static $fieldNames = array (
		User::TYPE_PHPNAME => array ('Id', 'Username', 'Password', 'LastLogin', 'RegDate', 'Level', 'Enabled', 'Posts', 'Comments', 'Timezone', 'Language', 'NewMsg', 'UnreadMsg', 'Email', 'Signiture', 'CustomInfo', ),
		User::TYPE_COLNAME => array (UserPeer::ID, UserPeer::USERNAME, UserPeer::PASSWORD, UserPeer::LAST_LOGIN, UserPeer::REG_DATE, UserPeer::LEVEL, UserPeer::ENABLED, UserPeer::POSTS, UserPeer::COMMENTS, UserPeer::TIMEZONE, UserPeer::LANGUAGE, UserPeer::NEW_MSG, UserPeer::UNREAD_MSG, UserPeer::EMAIL, UserPeer::SIGNITURE, UserPeer::CUSTOM_INFO, ),
		
		User::TYPE_FIELDNAME => array ('id', 'username', 'password', 'last_login', 'reg_date', 'level', 'enabled', 'posts', 'comments', 'timezone', 'language', 'new_msg', 'unread_msg', 'email', 'signiture', 'custom_info', ),
		
		User::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
	);

	/**
	 * holds an array of keys for quick access to the fieldnames array
	 *
	 * first dimension keys are the type constants
	 * e.g. self::$fieldNames[self::TYPE_PHPNAME]['Id'] = 0
	 */
	private static $fieldKeys = array (
		User::TYPE_PHPNAME => array ('Id' => 0, 'Username' => 1, 'Password' => 2, 'LastLogin' => 3, 'RegDate' => 4, 'Level' => 5, 'Enabled' => 6, 'Posts' => 7, 'Comments' => 8, 'Timezone' => 9, 'Language' => 10, 'NewMsg' => 11, 'UnreadMsg' => 12, 'Email' => 13, 'Signiture' => 14, 'CustomInfo' => 15, ),
		User::TYPE_COLNAME => array (UserPeer::ID => 0, UserPeer::USERNAME => 1, UserPeer::PASSWORD => 2, UserPeer::LAST_LOGIN => 3, UserPeer::REG_DATE => 4, UserPeer::LEVEL => 5, UserPeer::ENABLED => 6, UserPeer::POSTS => 7, UserPeer::COMMENTS => 8, UserPeer::TIMEZONE => 9, UserPeer::LANGUAGE => 10, UserPeer::NEW_MSG => 11, UserPeer::UNREAD_MSG => 12, UserPeer::EMAIL => 13, UserPeer::SIGNITURE => 14, UserPeer::CUSTOM_INFO => 15, ),
		
		User::TYPE_FIELDNAME => array ('id' => 0, 'username' => 1, 'password' => 2, 'last_login' => 3, 'reg_date' => 4, 'level' => 5, 'enabled' => 6, 'posts' => 7, 'comments' => 8, 'timezone' => 9, 'language' => 10, 'new_msg' => 11, 'unread_msg' => 12, 'email' => 13, 'signiture' => 14, 'custom_info' => 15, ),
		
		User::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
	);

	/**
	 * Collection to store aggregation of collUserGroups.
	 * @var array
	 */
	protected $collUserGroups;
	
	/**
	 * The criteria used to select the current contents of collUserGroups.
	 * @var Criteria
	 */
	private $lastUserGroupCriteria = null;

	/**
	 * Collection to store aggregation of collMessagesRelatedByFrom.
	 * @var array
	 */
	protected $collMessagesRelatedByFrom;
	
	/**
	 * The criteria used to select the current contents of collMessagesRelatedByFrom.
	 * @var Criteria
	 */
	private $lastMessageRelatedByFromCriteria = null;

	/**
	 * Collection to store aggregation of collMessagesRelatedByTo.
	 * @var array
	 */
	protected $collMessagesRelatedByTo;
	
	/**
	 * The criteria used to select the current contents of collMessagesRelatedByTo.
	 * @var Criteria
	 */
	private $lastMessageRelatedByToCriteria = null;

	/**
	 * Collection to store aggregation of collForums.
	 * @var array
	 */
	protected $collForums;
	
	/**
	 * The criteria used to select the current contents of collForums.
	 * @var Criteria
	 */
	private $lastForumCriteria = null;

	/**
	 * Collection to store aggregation of collTopics.
	 * @var array
	 */
	protected $collTopics;
	
	/**
	 * The criteria used to select the current contents of collTopics.
	 * @var Criteria
	 */
	private $lastTopicCriteria = null;

	/**
	 * Collection to store aggregation of collPosts.
	 * @var array
	 */
	protected $collPosts;
	
	/**
	 * The criteria used to select the current contents of collPosts.
	 * @var Criteria
	 */
	private $lastPostCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [username] column value.
	 * 
	 * @return string
	 */
	public function getUsername()
	{

		return $this->username;
	}

	/**
	 * Get the [password] column value.
	 * 
	 * @return string
	 */
	public function getPassword()
	{

		return $this->password;
	}

	/**
	 * Get the [optionally formatted] [last_login] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getLastLogin($format = 'Y-m-d H:i:s')
	{

		if ($this->last_login === null || $this->last_login === '') {
			return null;
		} elseif (!is_int($this->last_login)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->last_login);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of [last_login] as date/time value: " . var_export($this->last_login, true));
			}
		} else {
			$ts = $this->last_login;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [reg_date] column value.
	 * 
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getRegDate($format = 'Y-m-d H:i:s')
	{

		if ($this->reg_date === null || $this->reg_date === '') {
			return null;
		} elseif (!is_int($this->reg_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->reg_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of [reg_date] as date/time value: " . var_export($this->reg_date, true));
			}
		} else {
			$ts = $this->reg_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [level] column value.
	 * 
	 * @return int
	 */
	public function getLevel()
	{

		return $this->level;
	}

	/**
	 * Get the [enabled] column value.
	 * 
	 * @return boolean
	 */
	public function getEnabled()
	{

		return $this->enabled;
	}

	/**
	 * Get the [posts] column value.
	 * 
	 * @return int
	 */
	public function getPosts()
	{

		return $this->posts;
	}

	/**
	 * Get the [comments] column value.
	 * 
	 * @return int
	 */
	public function getComments()
	{

		return $this->comments;
	}

	/**
	 * Get the [timezone] column value.
	 * 
	 * @return int
	 */
	public function getTimezone()
	{

		return $this->timezone;
	}

	/**
	 * Get the [language] column value.
	 * 
	 * @return string
	 */
	public function getLanguage()
	{

		return $this->language;
	}

	/**
	 * Get the [new_msg] column value.
	 * 
	 * @return int
	 */
	public function getNewMsg()
	{

		return $this->new_msg;
	}

	/**
	 * Get the [unread_msg] column value.
	 * 
	 * @return int
	 */
	public function getUnreadMsg()
	{

		return $this->unread_msg;
	}

	/**
	 * Get the [email] column value.
	 * 
	 * @return string
	 */
	public function getEmail()
	{

		return $this->email;
	}

	/**
	 * Get the [signiture] column value.
	 * 
	 * @return string
	 */
	public function getSigniture()
	{

		return $this->signiture;
	}

	/**
	 * Get the [custom_info] column value.
	 * 
	 * @return string
	 */
	public function getCustomInfo()
	{

		return $this->custom_info;
	}

	/**
	 * Set the value of [id] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setId($v)
	{

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = UserPeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [username] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setUsername($v)
	{

		if ($this->username !== $v) {
			$this->username = $v;
			$this->modifiedColumns[] = UserPeer::USERNAME;
		}

	} // setUsername()

	/**
	 * Set the value of [password] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setPassword($v)
	{

		if ($this->password !== $v) {
			$this->password = $v;
			$this->modifiedColumns[] = UserPeer::PASSWORD;
		}

	} // setPassword()

	/**
	 * Set the value of [last_login] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setLastLogin($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for [last_login] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->last_login !== $ts) {
			$this->last_login = $ts;
			$this->modifiedColumns[] = UserPeer::LAST_LOGIN;
		}

	} // setLastLogin()

	/**
	 * Set the value of [reg_date] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setRegDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for [reg_date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->reg_date !== $ts) {
			$this->reg_date = $ts;
			$this->modifiedColumns[] = UserPeer::REG_DATE;
		}

	} // setRegDate()

	/**
	 * Set the value of [level] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setLevel($v)
	{

		if ($this->level !== $v) {
			$this->level = $v;
			$this->modifiedColumns[] = UserPeer::LEVEL;
		}

	} // setLevel()

	/**
	 * Set the value of [enabled] column.	  
	 * 
	 * @param boolean $v new value
	 * @return void
	 */
	public function setEnabled($v)
	{

		if ($this->enabled !== $v) {
			$this->enabled = $v;
			$this->modifiedColumns[] = UserPeer::ENABLED;
		}

	} // setEnabled()

	/**
	 * Set the value of [posts] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setPosts($v)
	{

		if ($this->posts !== $v) {
			$this->posts = $v;
			$this->modifiedColumns[] = UserPeer::POSTS;
		}

	} // setPosts()

	/**
	 * Set the value of [comments] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setComments($v)
	{

		if ($this->comments !== $v) {
			$this->comments = $v;
			$this->modifiedColumns[] = UserPeer::COMMENTS;
		}

	} // setComments()

	/**
	 * Set the value of [timezone] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setTimezone($v)
	{

		if ($this->timezone !== $v) {
			$this->timezone = $v;
			$this->modifiedColumns[] = UserPeer::TIMEZONE;
		}

	} // setTimezone()

	/**
	 * Set the value of [language] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setLanguage($v)
	{

		if ($this->language !== $v) {
			$this->language = $v;
			$this->modifiedColumns[] = UserPeer::LANGUAGE;
		}

	} // setLanguage()

	/**
	 * Set the value of [new_msg] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setNewMsg($v)
	{

		if ($this->new_msg !== $v) {
			$this->new_msg = $v;
			$this->modifiedColumns[] = UserPeer::NEW_MSG;
		}

	} // setNewMsg()

	/**
	 * Set the value of [unread_msg] column.	  
	 * 
	 * @param int $v new value
	 * @return void
	 */
	public function setUnreadMsg($v)
	{

		if ($this->unread_msg !== $v) {
			$this->unread_msg = $v;
			$this->modifiedColumns[] = UserPeer::UNREAD_MSG;
		}

	} // setUnreadMsg()

	/**
	 * Set the value of [email] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setEmail($v)
	{

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = UserPeer::EMAIL;
		}

	} // setEmail()

	/**
	 * Set the value of [signiture] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setSigniture($v)
	{

		if ($this->signiture !== $v) {
			$this->signiture = $v;
			$this->modifiedColumns[] = UserPeer::SIGNITURE;
		}

	} // setSigniture()

	/**
	 * Set the value of [custom_info] column.	  
	 * 
	 * @param string $v new value
	 * @return void
	 */
	public function setCustomInfo($v)
	{

		if ($this->custom_info !== $v) {
			$this->custom_info = $v;
			$this->modifiedColumns[] = UserPeer::CUSTOM_INFO;
		}

	} // setCustomInfo()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return int next starting column
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->username = $rs->getString($startcol + 1);

			$this->password = $rs->getString($startcol + 2);

			$this->last_login = $rs->getTimestamp($startcol + 3, null);

			$this->reg_date = $rs->getTimestamp($startcol + 4, null);

			$this->level = $rs->getInt($startcol + 5);

			$this->enabled = $rs->getBoolean($startcol + 6);

			$this->posts = $rs->getInt($startcol + 7);

			$this->comments = $rs->getInt($startcol + 8);

			$this->timezone = $rs->getInt($startcol + 9);

			$this->language = $rs->getString($startcol + 10);

			$this->new_msg = $rs->getInt($startcol + 11);

			$this->unread_msg = $rs->getInt($startcol + 12);

			$this->email = $rs->getString($startcol + 13);

			$this->signiture = $rs->getString($startcol + 14);

			$this->custom_info = $rs->getString($startcol + 15);

			$this->resetModified();

			$this->setNew(false);
						
			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 16; // 16 = UserPeer::NUM_COLUMNS - UserPeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating User object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			UserPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see doSave()
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UserPeer::DATABASE_NAME);
		}
		
		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 * 
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param Connection $con
	 * @return int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws PropelException
	 * @see save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows	
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;
	

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserPeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which 
										 // should always be true here (even though technically 
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += UserPeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collUserGroups !== null) {
				foreach($this->collUserGroups as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collMessagesRelatedByFrom !== null) {
				foreach($this->collMessagesRelatedByFrom as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collMessagesRelatedByTo !== null) {
				foreach($this->collMessagesRelatedByTo as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collForums !== null) {
				foreach($this->collForums as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collTopics !== null) {
				foreach($this->collTopics as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collPosts !== null) {
				foreach($this->collPosts as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 * @see doValidate()
	 */
	public function validate($columns = null)
	{
	  if ($columns) {
		return UserPeer::doValidate($this, $columns);
	  }
		return $this->doValidate();
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			if (($retval = UserPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collUserGroups !== null) {
					foreach($this->collUserGroups as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}

				if ($this->collMessagesRelatedByFrom !== null) {
					foreach($this->collMessagesRelatedByFrom as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}

				if ($this->collMessagesRelatedByTo !== null) {
					foreach($this->collMessagesRelatedByTo as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}

				if ($this->collForums !== null) {
					foreach($this->collForums as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}

				if ($this->collTopics !== null) {
					foreach($this->collTopics as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}

				if ($this->collPosts !== null) {
					foreach($this->collPosts as $referrerFK) {
						if (($retval = $referrerFK->validate()) !== true) {
							$failureMap = array_merge($failureMap, $retval);
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Translates a fieldname to another type
	 *
	 * @param string $name field name
	 * @param string $fromType One of the class type constants TYPE_PHPNAME,
	 *                         TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @param string $toType   One of the class type constants
	 * @return string translated name of the field.
	 */
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = self::$fieldKeys[$fromType][$name];
		if ($key === false) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r($fromNames, true));
		}
		return $toNames[$key];
	}

	/**
	 * Returns an array of of field names.
	 *
	 * @param  string $type The type of fieldnames to return:
	 *                      One of the class type constants TYPE_PHPNAME,
	 *                      TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return array A list of field names
	 */

	static public function getFieldNames($type = self::TYPE_FIELDNAME)
	{
		if (!isset(self::$fieldNames[$type])) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param string $name name
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return mixed Value of field.
	 */
	public function getByName($name, $type = self::TYPE_COLNAME)
	{
		$names = self::getFieldNames($type);
		$pos = self::translateFieldName($name, $type, self::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {

			case 0:
				return $this->getId();
				break;

			case 1:
				return $this->getUsername();
				break;

			case 2:
				return $this->getPassword();
				break;

			case 3:
				return $this->getLastLogin();
				break;

			case 4:
				return $this->getRegDate();
				break;

			case 5:
				return $this->getLevel();
				break;

			case 6:
				return $this->getEnabled();
				break;

			case 7:
				return $this->getPosts();
				break;

			case 8:
				return $this->getComments();
				break;

			case 9:
				return $this->getTimezone();
				break;

			case 10:
				return $this->getLanguage();
				break;

			case 11:
				return $this->getNewMsg();
				break;

			case 12:
				return $this->getUnreadMsg();
				break;

			case 13:
				return $this->getEmail();
				break;

			case 14:
				return $this->getSigniture();
				break;

			case 15:
				return $this->getCustomInfo();
				break;

			default:
				return null;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = self::TYPE_PHPNAME)
	{
		$keys = self::getFieldNames($keyType);
		$result = array(

			$keys[0] => $this->getId(),

			$keys[1] => $this->getUsername(),

			$keys[2] => $this->getPassword(),

			$keys[3] => $this->getLastLogin(),

			$keys[4] => $this->getRegDate(),

			$keys[5] => $this->getLevel(),

			$keys[6] => $this->getEnabled(),

			$keys[7] => $this->getPosts(),

			$keys[8] => $this->getComments(),

			$keys[9] => $this->getTimezone(),

			$keys[10] => $this->getLanguage(),

			$keys[11] => $this->getNewMsg(),

			$keys[12] => $this->getUnreadMsg(),

			$keys[13] => $this->getEmail(),

			$keys[14] => $this->getSigniture(),

			$keys[15] => $this->getCustomInfo(),

		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @param string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return void
	 */
	public function setByName($name, $value, $type = self::TYPE_COLNAME)
	{
		$names = $this->getFieldnames($type);
		$pos = array_search($name, $names);
		return $this->setByPosition($pos, $name);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {

			case 0:
				$this->setId($value);
				break;
		
			case 1:
				$this->setUsername($value);
				break;
		
			case 2:
				$this->setPassword($value);
				break;
		
			case 3:
				$this->setLastLogin($value);
				break;
		
			case 4:
				$this->setRegDate($value);
				break;
		
			case 5:
				$this->setLevel($value);
				break;
		
			case 6:
				$this->setEnabled($value);
				break;
		
			case 7:
				$this->setPosts($value);
				break;
		
			case 8:
				$this->setComments($value);
				break;
		
			case 9:
				$this->setTimezone($value);
				break;
		
			case 10:
				$this->setLanguage($value);
				break;
		
			case 11:
				$this->setNewMsg($value);
				break;
		
			case 12:
				$this->setUnreadMsg($value);
				break;
		
			case 13:
				$this->setEmail($value);
				break;
		
			case 14:
				$this->setSigniture($value);
				break;
		
			case 15:
				$this->setCustomInfo($value);
				break;
		
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the (peer) column name (e.g.
	 * 'book.AUTHOR_ID')
	 *
	 * @param array  $arr     An array to populate the object from.
	 * @param string $keyType The type of keys the array uses.
	 * @return void
	 */
	public function fromArray($arr, $keyType = self::TYPE_COLNAME)
	{
		$keys = self::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);

		if (array_key_exists($keys[1], $arr)) $this->setUsername($arr[$keys[1]]);

		if (array_key_exists($keys[2], $arr)) $this->setPassword($arr[$keys[2]]);

		if (array_key_exists($keys[3], $arr)) $this->setLastLogin($arr[$keys[3]]);

		if (array_key_exists($keys[4], $arr)) $this->setRegDate($arr[$keys[4]]);

		if (array_key_exists($keys[5], $arr)) $this->setLevel($arr[$keys[5]]);

		if (array_key_exists($keys[6], $arr)) $this->setEnabled($arr[$keys[6]]);

		if (array_key_exists($keys[7], $arr)) $this->setPosts($arr[$keys[7]]);

		if (array_key_exists($keys[8], $arr)) $this->setComments($arr[$keys[8]]);

		if (array_key_exists($keys[9], $arr)) $this->setTimezone($arr[$keys[9]]);

		if (array_key_exists($keys[10], $arr)) $this->setLanguage($arr[$keys[10]]);

		if (array_key_exists($keys[11], $arr)) $this->setNewMsg($arr[$keys[11]]);

		if (array_key_exists($keys[12], $arr)) $this->setUnreadMsg($arr[$keys[12]]);

		if (array_key_exists($keys[13], $arr)) $this->setEmail($arr[$keys[13]]);

		if (array_key_exists($keys[14], $arr)) $this->setSigniture($arr[$keys[14]]);

		if (array_key_exists($keys[15], $arr)) $this->setCustomInfo($arr[$keys[15]]);

	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(UserPeer::DATABASE_NAME);

		if ($this->isColumnModified(UserPeer::ID)) $criteria->add(UserPeer::ID, $this->id);

		if ($this->isColumnModified(UserPeer::USERNAME)) $criteria->add(UserPeer::USERNAME, $this->username);

		if ($this->isColumnModified(UserPeer::PASSWORD)) $criteria->add(UserPeer::PASSWORD, $this->password);

		if ($this->isColumnModified(UserPeer::LAST_LOGIN)) $criteria->add(UserPeer::LAST_LOGIN, $this->last_login);

		if ($this->isColumnModified(UserPeer::REG_DATE)) $criteria->add(UserPeer::REG_DATE, $this->reg_date);

		if ($this->isColumnModified(UserPeer::LEVEL)) $criteria->add(UserPeer::LEVEL, $this->level);

		if ($this->isColumnModified(UserPeer::ENABLED)) $criteria->add(UserPeer::ENABLED, $this->enabled);

		if ($this->isColumnModified(UserPeer::POSTS)) $criteria->add(UserPeer::POSTS, $this->posts);

		if ($this->isColumnModified(UserPeer::COMMENTS)) $criteria->add(UserPeer::COMMENTS, $this->comments);

		if ($this->isColumnModified(UserPeer::TIMEZONE)) $criteria->add(UserPeer::TIMEZONE, $this->timezone);

		if ($this->isColumnModified(UserPeer::LANGUAGE)) $criteria->add(UserPeer::LANGUAGE, $this->language);

		if ($this->isColumnModified(UserPeer::NEW_MSG)) $criteria->add(UserPeer::NEW_MSG, $this->new_msg);

		if ($this->isColumnModified(UserPeer::UNREAD_MSG)) $criteria->add(UserPeer::UNREAD_MSG, $this->unread_msg);

		if ($this->isColumnModified(UserPeer::EMAIL)) $criteria->add(UserPeer::EMAIL, $this->email);

		if ($this->isColumnModified(UserPeer::SIGNITURE)) $criteria->add(UserPeer::SIGNITURE, $this->signiture);

		if ($this->isColumnModified(UserPeer::CUSTOM_INFO)) $criteria->add(UserPeer::CUSTOM_INFO, $this->custom_info);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UserPeer::DATABASE_NAME);

		$criteria->add(UserPeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return int 
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param int $key Primary key.
	 * @return void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param object $copyObj An object of User (or compatible) type.
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setUsername($this->username);

		$copyObj->setPassword($this->password);

		$copyObj->setLastLogin($this->last_login);

		$copyObj->setRegDate($this->reg_date);

		$copyObj->setLevel($this->level);

		$copyObj->setEnabled($this->enabled);

		$copyObj->setPosts($this->posts);

		$copyObj->setComments($this->comments);

		$copyObj->setTimezone($this->timezone);

		$copyObj->setLanguage($this->language);

		$copyObj->setNewMsg($this->new_msg);

		$copyObj->setUnreadMsg($this->unread_msg);

		$copyObj->setEmail($this->email);

		$copyObj->setSigniture($this->signiture);

		$copyObj->setCustomInfo($this->custom_info);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getUserGroups() as $relObj) {
				$copyObj->addUserGroup($relObj->copy());
			}

			foreach($this->getMessagesRelatedByFrom() as $relObj) {
				$copyObj->addMessageRelatedByFrom($relObj->copy());
			}

			foreach($this->getMessagesRelatedByTo() as $relObj) {
				$copyObj->addMessageRelatedByTo($relObj->copy());
			}

			foreach($this->getForums() as $relObj) {
				$copyObj->addForum($relObj->copy());
			}

			foreach($this->getTopics() as $relObj) {
				$copyObj->addTopic($relObj->copy());
			}

			foreach($this->getPosts() as $relObj) {
				$copyObj->addPost($relObj->copy());
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 * 
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return User Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * 
	 * @return UserPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserPeer();
		}
		return self::$peer;
	}

	/**
	 * Temporary storage of collUserGroups to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserGroups()
	{
		if ($this->collUserGroups === null) {
			$this->collUserGroups = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related UserGroups from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserGroups($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseUserGroupPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collUserGroups === null) {
			if ($this->isNew()) {
			   $this->collUserGroups = array();
			} else {

				$criteria->add(UserGroupPeer::USER_ID, $this->getId());

				UserGroupPeer::addSelectColumns($criteria);
				$this->collUserGroups = UserGroupPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(UserGroupPeer::USER_ID, $this->getId());

				UserGroupPeer::addSelectColumns($criteria);
				if (!isset($this->lastUserGroupCriteria) || !$this->lastUserGroupCriteria->equals($criteria)) {
					$this->collUserGroups = UserGroupPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserGroupCriteria = $criteria;
		return $this->collUserGroups;
	}

	/**
	 * Returns the number of related UserGroups.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countUserGroups($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseUserGroupPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(UserGroupPeer::USER_ID, $this->getId());

		return UserGroupPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a UserGroup object to this object
	 * through the UserGroup foreign key attribute
	 *
	 * @param UserGroup $l UserGroup
	 * @return void
	 * @throws PropelException
	 */
	public function addUserGroup(UserGroup $l)
	{
		$this->collUserGroups[] = $l;
		$l->setUser($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related UserGroups from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getUserGroupsJoinGroup($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseUserGroupPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collUserGroups === null) {
			if ($this->isNew()) {
				$this->collUserGroups = array();
			} else {

				$criteria->add(UserGroupPeer::USER_ID, $this->getId());

				$this->collUserGroups = UserGroupPeer::doSelectJoinGroup($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(UserGroupPeer::USER_ID, $this->getId());

			if (!isset($this->lastUserGroupCriteria) || !$this->lastUserGroupCriteria->equals($criteria)) {
				$this->collUserGroups = UserGroupPeer::doSelectJoinGroup($criteria, $con);
			}
		}
		$this->lastUserGroupCriteria = $criteria;

		return $this->collUserGroups;
	}

	/**
	 * Temporary storage of collMessagesRelatedByFrom to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMessagesRelatedByFrom()
	{
		if ($this->collMessagesRelatedByFrom === null) {
			$this->collMessagesRelatedByFrom = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related MessagesRelatedByFrom from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMessagesRelatedByFrom($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collMessagesRelatedByFrom === null) {
			if ($this->isNew()) {
			   $this->collMessagesRelatedByFrom = array();
			} else {

				$criteria->add(MessagePeer::FROM, $this->getId());

				MessagePeer::addSelectColumns($criteria);
				$this->collMessagesRelatedByFrom = MessagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(MessagePeer::FROM, $this->getId());

				MessagePeer::addSelectColumns($criteria);
				if (!isset($this->lastMessageRelatedByFromCriteria) || !$this->lastMessageRelatedByFromCriteria->equals($criteria)) {
					$this->collMessagesRelatedByFrom = MessagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMessageRelatedByFromCriteria = $criteria;
		return $this->collMessagesRelatedByFrom;
	}

	/**
	 * Returns the number of related MessagesRelatedByFrom.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countMessagesRelatedByFrom($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(MessagePeer::FROM, $this->getId());

		return MessagePeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Message object to this object
	 * through the Message foreign key attribute
	 *
	 * @param Message $l Message
	 * @return void
	 * @throws PropelException
	 */
	public function addMessageRelatedByFrom(Message $l)
	{
		$this->collMessagesRelatedByFrom[] = $l;
		$l->setUserRelatedByFrom($this);
	}

	/**
	 * Temporary storage of collMessagesRelatedByTo to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMessagesRelatedByTo()
	{
		if ($this->collMessagesRelatedByTo === null) {
			$this->collMessagesRelatedByTo = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related MessagesRelatedByTo from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMessagesRelatedByTo($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collMessagesRelatedByTo === null) {
			if ($this->isNew()) {
			   $this->collMessagesRelatedByTo = array();
			} else {

				$criteria->add(MessagePeer::TO, $this->getId());

				MessagePeer::addSelectColumns($criteria);
				$this->collMessagesRelatedByTo = MessagePeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(MessagePeer::TO, $this->getId());

				MessagePeer::addSelectColumns($criteria);
				if (!isset($this->lastMessageRelatedByToCriteria) || !$this->lastMessageRelatedByToCriteria->equals($criteria)) {
					$this->collMessagesRelatedByTo = MessagePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMessageRelatedByToCriteria = $criteria;
		return $this->collMessagesRelatedByTo;
	}

	/**
	 * Returns the number of related MessagesRelatedByTo.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countMessagesRelatedByTo($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseMessagePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(MessagePeer::TO, $this->getId());

		return MessagePeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Message object to this object
	 * through the Message foreign key attribute
	 *
	 * @param Message $l Message
	 * @return void
	 * @throws PropelException
	 */
	public function addMessageRelatedByTo(Message $l)
	{
		$this->collMessagesRelatedByTo[] = $l;
		$l->setUserRelatedByTo($this);
	}

	/**
	 * Temporary storage of collForums to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initForums()
	{
		if ($this->collForums === null) {
			$this->collForums = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Forums from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getForums($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseForumPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collForums === null) {
			if ($this->isNew()) {
			   $this->collForums = array();
			} else {

				$criteria->add(ForumPeer::LAST_POSTER, $this->getId());

				ForumPeer::addSelectColumns($criteria);
				$this->collForums = ForumPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(ForumPeer::LAST_POSTER, $this->getId());

				ForumPeer::addSelectColumns($criteria);
				if (!isset($this->lastForumCriteria) || !$this->lastForumCriteria->equals($criteria)) {
					$this->collForums = ForumPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastForumCriteria = $criteria;
		return $this->collForums;
	}

	/**
	 * Returns the number of related Forums.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countForums($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseForumPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(ForumPeer::LAST_POSTER, $this->getId());

		return ForumPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Forum object to this object
	 * through the Forum foreign key attribute
	 *
	 * @param Forum $l Forum
	 * @return void
	 * @throws PropelException
	 */
	public function addForum(Forum $l)
	{
		$this->collForums[] = $l;
		$l->setUser($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Forums from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getForumsJoinCategory($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseForumPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collForums === null) {
			if ($this->isNew()) {
				$this->collForums = array();
			} else {

				$criteria->add(ForumPeer::LAST_POSTER, $this->getId());

				$this->collForums = ForumPeer::doSelectJoinCategory($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(ForumPeer::LAST_POSTER, $this->getId());

			if (!isset($this->lastForumCriteria) || !$this->lastForumCriteria->equals($criteria)) {
				$this->collForums = ForumPeer::doSelectJoinCategory($criteria, $con);
			}
		}
		$this->lastForumCriteria = $criteria;

		return $this->collForums;
	}

	/**
	 * Temporary storage of collTopics to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTopics()
	{
		if ($this->collTopics === null) {
			$this->collTopics = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Topics from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTopics($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseTopicPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collTopics === null) {
			if ($this->isNew()) {
			   $this->collTopics = array();
			} else {

				$criteria->add(TopicPeer::POSTER, $this->getId());

				TopicPeer::addSelectColumns($criteria);
				$this->collTopics = TopicPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(TopicPeer::POSTER, $this->getId());

				TopicPeer::addSelectColumns($criteria);
				if (!isset($this->lastTopicCriteria) || !$this->lastTopicCriteria->equals($criteria)) {
					$this->collTopics = TopicPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTopicCriteria = $criteria;
		return $this->collTopics;
	}

	/**
	 * Returns the number of related Topics.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countTopics($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseTopicPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(TopicPeer::POSTER, $this->getId());

		return TopicPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Topic object to this object
	 * through the Topic foreign key attribute
	 *
	 * @param Topic $l Topic
	 * @return void
	 * @throws PropelException
	 */
	public function addTopic(Topic $l)
	{
		$this->collTopics[] = $l;
		$l->setUser($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Topics from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getTopicsJoinForum($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BaseTopicPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collTopics === null) {
			if ($this->isNew()) {
				$this->collTopics = array();
			} else {

				$criteria->add(TopicPeer::POSTER, $this->getId());

				$this->collTopics = TopicPeer::doSelectJoinForum($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(TopicPeer::POSTER, $this->getId());

			if (!isset($this->lastTopicCriteria) || !$this->lastTopicCriteria->equals($criteria)) {
				$this->collTopics = TopicPeer::doSelectJoinForum($criteria, $con);
			}
		}
		$this->lastTopicCriteria = $criteria;

		return $this->collTopics;
	}

	/**
	 * Temporary storage of collPosts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPosts()
	{
		if ($this->collPosts === null) {
			$this->collPosts = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User has previously
	 * been saved, it will retrieve related Posts from storage.
	 * If this User is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPosts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
			   $this->collPosts = array();
			} else {

				$criteria->add(PostPeer::POSTER, $this->getId());

				PostPeer::addSelectColumns($criteria);
				$this->collPosts = PostPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(PostPeer::POSTER, $this->getId());

				PostPeer::addSelectColumns($criteria);
				if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
					$this->collPosts = PostPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPostCriteria = $criteria;
		return $this->collPosts;
	}

	/**
	 * Returns the number of related Posts.
	 *
	 * @param Criteria $criteria
	 * @param Connection $con
	 * @throws PropelException
	 */
	public function countPosts($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		$criteria->add(PostPeer::POSTER, $this->getId());

		return PostPeer::doCount($criteria, $con);
	}

	/**
	 * Method called to associate a Post object to this object
	 * through the Post foreign key attribute
	 *
	 * @param Post $l Post
	 * @return void
	 * @throws PropelException
	 */
	public function addPost(Post $l)
	{
		$this->collPosts[] = $l;
		$l->setUser($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getPostsJoinTopic($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::POSTER, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinTopic($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::POSTER, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinTopic($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getPostsJoinForum($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::POSTER, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinForum($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::POSTER, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinForum($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this User is new, it will return
	 * an empty collection; or if this User has previously
	 * been saved, it will retrieve related Posts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in User.
	 */
	public function getPostsJoinPostRelatedByReplyOf($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'model/om/BasePostPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}

		if ($this->collPosts === null) {
			if ($this->isNew()) {
				$this->collPosts = array();
			} else {

				$criteria->add(PostPeer::POSTER, $this->getId());

				$this->collPosts = PostPeer::doSelectJoinPostRelatedByReplyOf($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(PostPeer::POSTER, $this->getId());

			if (!isset($this->lastPostCriteria) || !$this->lastPostCriteria->equals($criteria)) {
				$this->collPosts = PostPeer::doSelectJoinPostRelatedByReplyOf($criteria, $con);
			}
		}
		$this->lastPostCriteria = $criteria;

		return $this->collPosts;
	}

} // BaseUser
